import React from 'react';
import PropTypes from 'prop-types';
import styles from './index.scss';
import Group from './ButtonGroup';

const Button = (props) => {
  const {children, type, size, disabled, onClick, style} = props;
  const thisClick = () => {
    if (onClick) {
      onClick();
    }
  }
  // large => lg
  // small => sm
  let sizeCls = '';

  switch (size) {
    case 'large':
      sizeCls = 'lg';
      break;
    case 'small':
      sizeCls = 'sm';
    default:
      break;
  };

  let disabledCls = '';

  switch (disabled) {
    case 'disabled':
      disabledCls = 'disabled';
      break;
    default:
      break;
  };

  let content = React.Children.map(children, (item, index) => {

    if (typeof(item) == "string" && typeof(children) != "string") {
      let text = index === 0
        ? (<span className={styles.mr}>{item}</span>)
        : (<span className={styles.ml}>{item}</span>);
      return text;
    } else {
      return (item);
    }
  });

  let _hover = type ==='primary' ? 'car-bg-secend-hover__vi'
      : 'car-border-hover__vi';
  let _bc =  type ==='primary' ? 'car-bg__vi' : ''

  if(disabled){
    _hover = '';
    _bc = '';
  }

  return (
    <div 
      style={style}  
      className={`${styles['car-btn']} ${styles['car-btn-' + type]} ${styles['car-btn-' + sizeCls]}  ${styles[disabledCls]} ${_hover} ${_bc} `} 
      onClick={thisClick}
    >
      {content}
    </div>
  );

}
//验证参数
Button.propTypes = {
  type: PropTypes.string.isRequired,
  size: PropTypes.string,
  disabled: PropTypes.string
}
export default Button;
