import React, { Component } from 'react';
import PropTypes from 'prop-types';
import styles from './index.scss';
import Icon from './../Icon';
import Button from './Button';
import _event from '../event';
// 点击外隐藏
const getNode = (node) => {
  if (node.tagName === 'BODY') {
    return true;
  } else if (node.hasAttribute('data-drop')) {
    return false;
  } else {
    return getNode(node.parentNode)
  }
}
class Dorpdown extends Component {

  constructor(props, content) {
    super(props);
    this.handleOpen = this.handleOpen.bind(this);
    this.state = {
      open: false,
      active: false
    }
  }

  handleOpen(e) {
    this.setState((prevState) => {
      return {
        open: !this.state.open,
        active: true
      }
    })

    if (this.state.open) {
      this.setState((prevState) => {
        return {
          open: !this.state.open,
          active: false
        }
      })
    }
  }

  dropBlur = (target) => {
    if (this.state.active) {
      this.setState({ 'open': true, 'active': false });
    } else {
      this.setState({ 'open': false, 'active': false });
    }

  }
  // 销毁事件
  componentWillUnmount() {
    _event.removeEvent(document, 'click', this.dropBlur);
  }
  // 绑定d点击组件外 隐藏当前下拉事件
  componentDidMount() {

    this.setState({ 'activeItem': this.props.value })
    _event.addEvent(document, 'click', this.dropBlur);

  }

  render() {
    const { size, icon, title, children, placement, style, ...other } = this.props;
    const placeStyle = placement == 'right'
      ? {
        'right': 0
      }
      : {
        'left': 0
      };
    const itemList = React.Children.map(children, (item) => {
      if (item) {
        return React.cloneElement(item, { setDropdown: this.handleOpen });
      } else {
        return '';
      }

    });
    //下拉框打开样式
    const openCls = this.state.open && this.props.icon === 'xiala'
      ? 'car-select-dropdown-open'
      : '';

    return (
      <div
        {...other}
        style={style}
        className={`${styles['car-dorpdown']} ${styles[openCls]}`}
        data-drop='select'>
        <Button
          type={'default'}
          onClick={this.handleOpen}
          size={size}>
          {title}
          <Icon type={icon} />
        </Button>
        {
          this.state.open &&
          <ul
            style={placeStyle}
            className={styles['car-dorp-items']}
            data-drop='select'>
            {itemList}
          </ul>
        }

      </div>)
  }
}
export default Dorpdown
