import {Component} from 'react';
import styles from './style.scss';
import highchart from './highchart';

class ChartItem extends Component {

  componentDidMount() {
    const { option } = this.props;
    if (!option) return;

    this.chart = highchart.chart(this.chartBox, option);
  }

  componentWillReceiveProps(newProps) {
    const { option } = newProps;
    if (!option || !this.chart) return;
    this.chart.update(option)
  }

  componentDidUpdate() {
    if (this.chart) {
      setTimeout(()=>{
        this.chart.setSize();
        this.chart.reflow();
        this.chart.redraw();
      }, 0)
    }
  }

  render() {
    const {option, style} = this.props;

    return (
      <div
        style={{ ...style }}
        ref={(chart) => { this.chartBox = chart }}>
      </div>
    )
  }
}

export default ChartItem
