const Highcharts = require('highcharts/highstock');
require('highcharts/modules/exporting')(Highcharts);

// 获取存储的high主题
import {
  getEvent
} from '../../../tool/setThem';


function setOpt() {
  var obj;

  return function () {
    if (obj) {
      return obj
    } else {
      // 获取主题配置
      let opt = getEvent('chartObj');

      if (!opt) {
        return {}
      }
      let {
        ft1,
        ft2,
        cl1,
        cl2,
        ff
      } = opt;

      obj = {
        lang: {
          thousandsSep: ','
        },
        chart: {
          style: {
            fontFamily: ff,
            fontSize: ft1,
            color: cl1
          }
        },
        title: {
          style: {
            fontFamily: ff,
            fontSize: ft2,
            color: cl1
          }
        },
        subtitle: {
          style: {
            fontFamily: ff,
            fontSize: ft1,
            color: cl2
          }
        },
        xAxis: {
          labels: {
            style: {
              fontFamily: ff,
              fontSize: ft1,
              color: cl2
            }
          }
        },
        yAxis: {
          labels: {
            style: {
              fontFamily: ff,
              fontSize: ft1,
              color: cl2
            }
          }
        },
        zAxis: {
          labels: {
            style: {
              fontFamily: ff,
              fontSize: ft1,
              color: cl2
            }
          }
        },
        tooltip: {
          headerFormat: '<span >{point.key}</span><br/>',
          style: {
            fontFamily: ff,
            fontSize: ft2,
            color: cl1
          }
        },
        labels: {
          style: {
            fontFamily: ff,
            fontSize: ft2,
            color: cl2
          }
        },

        legend: {
          itemStyle: {
            fontFamily: ff,
            fontSize: ft2,
            color: cl1
          }
        },
        plotOptions: {
          series: { // 针对所有数据列有效的配置
            dataLabels: {
              style: {
                fontFamily: ff,
                fontSize: ft2,
                color: cl2
              }
            }
          }
        }
      }

      return obj
    }
  }
}

let _opt = setOpt()();

Highcharts.setOptions(
  _opt,
  global: {
  useUTC: true
}
);

export default Highcharts;
