import {Component} from 'react';
import styles from './style.scss';
import highchart from './highchart';

class ChartItem extends Component {
  state = {
    tempChart: null,
    option: null
  }

  componentDidMount() {
    const {
      loadOk,
      option,
    } = this.props;
    if (!option) return;

    let tempChart = highchart.stockChart(this.chartBox, option);
    this.setState({tempChart, option: option});
    loadOk(tempChart);
  }

  componentWillReceiveProps(newProps) {
    const {
      loadOk,
      option,
    } = newProps;
    if (!option || !this.state.tempChart) return;

    let {option: nowOption, tempChart: oldChart} = this.state;

    // 如果没有变化不进行渲染
    if (JSON.stringify(nowOption) == JSON.stringify(option) || oldChart == null) {
      return
    }

    let tempChart = highchart.chart(this.chartBox, option);
    this.setState({tempChart, option: option})
    loadOk(tempChart);
  }

  // 组件卸载后销毁图表
  componentWillUnmount() {
    this.setState = null;
    const {option} = this.props;
    const {tempChart} = this.state
    // if (option && tempChart != null) {
    //   // 销毁图表
    //   this.state.tempChart.destroy()
    // }
  }

  componentDidUpdate() {
    if (this.state.tempChart) {
      this.state.tempChart.reflow()
    }
  }

  render() {
    const {option, style} = this.props;
    if (!option) {
      return (<div className={styles.noData}>
        <p>没有数据</p>
      </div>)
    }

    return (
      <div
        style={{ ...style }}
        ref={(chart) => { this.chartBox = chart }}
      />
    )
  }
}

export default ChartItem
