import { Component } from 'react';
import styles from './style.scss';

import Loading from './Loading';
import ChartTable from './ChartTable';
import ChartTitle from './ChartTitle';
import ChartItem from './ChartItem';
import ChartStock from './ChartStock'

import ButtonGroup from '_c/Button/ButtonGroup';
import Dorpdown from '_c/Button/Dropdown'
import DorpItem from '_c/Button/DropItem'

let colors = []

let list = [
    [
        122222222222222222222, 2, 3
    ],
    [
        4, 5, 6
    ],
    [
        '7122222222222222222222122222222222222222222', 8, 9
    ]
]

let option = {
    "chart": {
        "marginRight": 10,
        "marginTop": 40,
        "marginBottom": 40,
        "type": "scatter"
    },
    "title": {
        "text": null
    },
    "exporting": {
        "enabled": false,
        "filename": "热门指标矩阵"
    },
    "credits": {
        "enabled": false
    },
    "legend": {
        "enabled": false
    },
    "colors": [
        "#ff4949",
        "#00d5a9",
        "#fff000",
        "#ff006c",
        "#e500ff",
        "#ff5629",
        "#6c00ff",
        "#0096ff",
        "#00d92e",
        "#00fcff",
        "#dc0000",
        "#ff9600",
        "#005fd5",
        "#a7de00",
        "#b7c0ff"
    ],
    "tooltip": {
        "shared": true,
        "crosshairs": true,
        "backgroundColor": "rgba(0, 0, 0, .7)",
        "borderWidth": 0,
        "borderRadius": 8,
        "shadow": false,
        "useHTML": true,
        "style": {
            "color": "#ffffff"
        }
    },
    "xAxis": {
        "color": "#fff",
        "tickWidth": 0,
        "lineWidth": 1,
        "crosshair": {
            "dashStyle": "dash",
            "width": 1
        },
        "labels": {
            "style": {
                "textOverflow": "none",
                "whiteSpace": "nowrap"
            }
        },
        "title": {
            "text": "情感指数",
            "align": "high",
            "rotation": 0,
            "offset": -10,
            "y": 35
        },
        "lineColor": "#ddd",
        "plotLines": [
            {
                "dashStyle": "ShortDash",
                "width": 1,
                "value": -0.14,
                "zIndex": 1,
                "label": {
                    "rotation": 0,
                    "style": {
                        "color": "#6b7897"
                    },
                    "text": "-0.14"
                },
                "color": "#efefef"
            }
        ],
        "max": 1,
        "min": -1
    },
    "yAxis": {
        "title": {
            "text": "声量",
            "align": "high",
            "rotation": 0,
            "offset": -45,
            "y": -15
        },
        "lineWidth": 1,
        "lineColor": "#efefef",
        "labels": {

        },
        "crosshair": {
            "dashStyle": "dash"
        },
        "gridLineWidth": 0,
        "plotLines": [
            {
                "dashStyle": "ShortDash",
                "width": 1,
                "value": 70.9,
                "zIndex": 1,
                "label": {
                    "align": "right",
                    "rotation": 0,
                    "style": {
                        "writingMode": "tb-rl",
                        "color": "red"
                    },
                    "text": "70.9"
                },
                "color": "#efefef"
            }
        ]
    },
    "plotOptions": {
        "series": {
            "dataLabels": {
                "align": "center",
                "y": -10,
                "allowOverlap": true,
                "enabled": true,
                "style": {
                    "fontWeight": 500
                }
            },
            "marker": {
                "enabled": true,
                "symbol": "circle"
            }
        }
    },
    "textColors": [
        "#d9d9d9",
        "#29a2fc",
        "#f99421"
    ],
    "strokeColors": [
        "#a1a1a1",
        "#4dabef",
        "#f98288"
    ],
    "series": [
        {
            "name": "噪音异响控制",
            "cursor": "pointer",
            "color": "#f99421",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#f99421",
                "lineWidth": 1,
                "lineColor": "#f99421"
            },
            "index_id": 1504,
            "data": [
                [
                    -0.89,
                    141
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "内饰整体",
            "cursor": "pointer",
            "color": "#f99421",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#f99421",
                "lineWidth": 1,
                "lineColor": "#f99421"
            },
            "index_id": 1404,
            "data": [
                [
                    -0.38,
                    105
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "整车价格",
            "cursor": "pointer",
            "color": "#29a2fc",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#29a2fc",
                "lineWidth": 1,
                "lineColor": "#29a2fc"
            },
            "index_id": 35,
            "data": [
                [
                    0.22,
                    257
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "优惠促销",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 34,
            "data": [
                [
                    0.74,
                    60
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "外观造型",
            "cursor": "pointer",
            "color": "#29a2fc",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#29a2fc",
                "lineWidth": 1,
                "lineColor": "#29a2fc"
            },
            "index_id": 1607,
            "data": [
                [
                    0.79,
                    80
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "音响",
            "cursor": "pointer",
            "color": "#29a2fc",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#29a2fc",
                "lineWidth": 1,
                "lineColor": "#29a2fc"
            },
            "index_id": 1704,
            "data": [
                [
                    -0.03,
                    81
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "动力性感受",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1203,
            "data": [
                [
                    0.33,
                    62
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "其他动力性评价",
            "cursor": "pointer",
            "color": "#f99421",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#f99421",
                "lineWidth": 1,
                "lineColor": "#f99421"
            },
            "index_id": 1206,
            "data": [
                [
                    -0.46,
                    93
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "车外灯",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1605,
            "data": [
                [
                    0.04,
                    56
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "空调",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1403,
            "data": [
                [
                    0,
                    51
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "抖动震动",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1500,
            "data": [
                [
                    -0.9,
                    26
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "变速器/变速箱",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1100,
            "data": [
                [
                    -0.6,
                    32
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "车轮",
            "cursor": "pointer",
            "color": "#f99421",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#f99421",
                "lineWidth": 1,
                "lineColor": "#f99421"
            },
            "index_id": 1602,
            "data": [
                [
                    -0.53,
                    71
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "操控性感受",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1101,
            "data": [
                [
                    0.29,
                    35
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "交车过程",
            "cursor": "pointer",
            "color": "#29a2fc",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#29a2fc",
                "lineWidth": 1,
                "lineColor": "#29a2fc"
            },
            "index_id": 2301,
            "data": [
                [
                    0.18,
                    129
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "油耗整体评价",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1810,
            "data": [
                [
                    0.63,
                    40
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "转向系统",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1109,
            "data": [
                [
                    -0.63,
                    21
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "性价比",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 33,
            "data": [
                [
                    0.38,
                    17
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "乘坐空间",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1301,
            "data": [
                [
                    -0.23,
                    25
                ]
            ],
            "point": {
                "events": {

                }
            }
        },
        {
            "name": "其他外观评价",
            "cursor": "pointer",
            "color": "#d9d9d9",
            "dataLabels": {
                "style": {
                    "textOutline": "none"
                }
            },
            "marker": {
                "radius": 6,
                "symbol": "circle",
                "fillColor": "#d9d9d9",
                "lineWidth": 1,
                "lineColor": "#d9d9d9"
            },
            "index_id": 1606,
            "data": [
                [
                    -0.17,
                    36
                ]
            ],
            "point": {
                "events": {

                }
            }
        }
    ]
};

let tdStyle = {
    td_1: {
        maxWidth: '50px'
    },
    td_3: {
        maxWidth: '50px'
    }
}

class Chart extends Component {
    constructor(props) {
        super(props)
        this.state = {
            showType: 'chart', // 显示图表还是表格
            showTypeName: '图形', //
            chartList: [], //
        }
    }

    // 表格和图表切换
    setShowType = (value) => {
        let showType;
        switch (value) {
            case '图形':
                showType = 'chart'
                break;
            case '表格':
                showType = 'table'
                break;
        }
        this.setState({ showTypeName: value, showType })
    }

    setChartList = (value) => {
        let temp = this.state.chartList;
        temp.push(value)
        this.setState(() => {
            return { chartList: temp }
        })
    }

    down = async (value) => {
        if (value === 'excel') {
            const { uuid } = this.props;
            server.downexcel(uuid)
        } else {

            const { chartList } = this.state;

            chartList.forEach((item, i) => {
                this.exportChart(item, '测试下栽', value, i);
            })
        }
    }

    exportChart = (chart, name, value, index) => {
        chart.exportChartLocal({ sourceWidth: chart.chartWidth, sourceHeight: chart.chartHeight, type: `${value}`, scale: 1, filename: name });
    }

    PointMouseOver = async (name) => {
        const { chartList } = this.state;
        const { pie } = this.props;
        let active = colors.length === chartList.length;
        await chartList.forEach((item, i) => {
            let tempArr = item.series[0].data;
            tempArr = tempArr.filter(now1 => {
                return name == now1.category
            })[0]
            if (!active) {
                if (pie) {
                    colors = tempArr.color
                } else {
                    if (typeof colors == 'string') {
                        colors = []
                    }
                    colors = [
                        ...colors,
                        tempArr.color
                    ]
                }
            }
            tempArr.color = 'red';
            tempArr.select()
        })
    }

    PointMouseOut = (name) => {
        const { chartList } = this.state
        const { pie } = this.props;
        chartList.forEach((item, i) => {
            let tempArr = item.series[0].data;
            tempArr = tempArr.filter(now1 => name == now1.category)[0]
            if (pie) {
                tempArr.color = colors
            } else {
                tempArr.color = colors[i];
            }
            tempArr.select()
        })
    }

    render() {
        const { showType, showTypeName } = this.state;
        const { loading, title, style } = this.props;

        // 判断图表是否加载完成
        if (!loading) {
            return (<Loading />)
        }

        // 显示图表还是表格
        const showView = () => {
            if (showType === 'table') {
                return (<ChartTable tdStyle={tdStyle} list={list} />)
            } else {
                return (<div className={styles.chartBox}>
                    {
                        <ChartItem option={option} loadOk={this.setChartList} />
                    }
                </div>)
            }
        }

        const showContrullBar = () => {
            return (<div className={styles.selectGroup}>
                <ButtonGroup>
                    <Dorpdown data-role="chartAndExcelSwitch" size={'small'} icon={'xiala'} title={showTypeName}>
                        <DorpItem onClick={this.setShowType}>图形</DorpItem>
                        <DorpItem onClick={this.setShowType}>表格</DorpItem>
                    </Dorpdown>
                    <Dorpdown data-role="download" size={'small'} icon={'xiazai'} title={'下载'} placement='right'>
                        <DorpItem onClick={this.down.bind(this, 'image/jpeg')}>下载JPG</DorpItem>
                        <DorpItem onClick={this.down.bind(this, 'image/png')}>下载PNG</DorpItem>
                        <DorpItem>下载EXCEL</DorpItem>
                    </Dorpdown>
                </ButtonGroup>
            </div>)
        }

        return (
            <div className={styles['car-chart']}>
                <div className={styles.chart}>
                    {/* 头部标题和样本量 */}
                    <ChartTitle title={title} /> {/* 控制菜单 */}

                    {/* 显示控制条 */}
                    {showContrullBar()}

                    {/* 显示图表 */}
                    {showView()}
                </div>
            </div>
        )
    }
}

export default Chart
