import {Component} from 'react';
import styles from './style.scss';

import Loading from './Loading';
import ChartTable from './ChartTable';
import ChartTitle from './ChartTitle';
import ChartItemLoad from './ChartItemLoad';
import ChartStock from './ChartStock'

import ButtonGroup from '_c/Button/ButtonGroup';
import Dorpdown from '_c/Button/Dropdown'
import DorpItem from '_c/Button/DropItem'

let colors = []

let list = [
  [
    122222222222222222222, 2, 3
  ],
  [
    4, 5, 6
  ],
  [
    '7122222222222222222222122222222222222222222', 8, 9
  ]
]

let option = {
  title: { text: null },
  credits: {
    enabled: false
  },
  exporting: {
    enabled: false
  },
	xAxis: {
    labels: {
			format: '{value}'
		}
	},
  navigator: {
    xAxis: {
      labels: {
  			format: '{value}'
  		}
    }
  },
	rangeSelector : {
		enabled: false
	},
	tooltip: {
		enabled: false
	},
	series : [{
		name : 'AAPL',
		type: 'spline',
		data : [[-90,17],[-89,18],[-87,155],[-86,22],[-85,35],[-84,35],[-83,35],[-82,35],[-81,35],[-80,35],[-79,35]],
		gapSize: 5,
		tooltip: {
			valueDecimals: 2
		},
		threshold: null
	}]
};

let tdStyle = {
  td_1: {
    maxWidth: '50px'
  },
  td_3: {
    maxWidth: '50px'
  }
}

class Chart extends Component {
  constructor(props) {
    super(props)
    this.state = {
      showType: 'chart', // 显示图表还是表格
      showTypeName: '图形', //
      chartList: [], //
    }
  }

  // 表格和图表切换
  setShowType = (value) => {
    let showType;
    switch (value) {
      case '图形':
        showType = 'chart'
        break;
      case '表格':
        showType = 'table'
        break;
    }
    this.setState({showTypeName: value, showType})
  }

  setChartList = (value) => {
    let temp = this.state.chartList;
    temp.push(value)
    this.setState(() => {
      return {chartList: temp}
    })
  }

  down = async (value) => {
    if (value === 'excel') {
      const {uuid} = this.props;
      server.downexcel(uuid)
    } else {

      const {chartList} = this.state;

      chartList.forEach((item, i) => {
        this.exportChart(item, '测试下栽', value, i);
      })
    }
  }

  exportChart = (chart, name, value, index) => {
    chart.exportChartLocal({
      sourceWidth: chart.chartWidth,
      sourceHeight: chart.chartHeight,
      type: `${value}`,
      scale: 1,
      filename: name
    });
  }

  PointMouseOver = async (name) => {
    const {chartList} = this.state;
    const {pie} = this.props;
    let active = colors.length === chartList.length;
    await chartList.forEach((item, i) => {
      let tempArr = item.series[0].data;
      tempArr = tempArr.filter(now1 => {
        return name == now1.category
      })[0]
      if (!active) {
        if (pie) {
          colors = tempArr.color
        } else {
          if (typeof colors == 'string') {
            colors = []
          }
          colors = [
            ...colors,
            tempArr.color
          ]
        }
      }
      tempArr.color = 'red';
      tempArr.select()
    })
  }

  PointMouseOut = (name) => {
    const {chartList} = this.state
    const {pie} = this.props;
    chartList.forEach((item, i) => {
      let tempArr = item.series[0].data;
      tempArr = tempArr.filter(now1 => name == now1.category)[0]
      if (pie) {
        tempArr.color = colors
      } else {
        tempArr.color = colors[i];
      }
      tempArr.select()
    })
  }

  render() {
    const {showType, showTypeName} = this.state;
    const {loading, title, style} = this.props;

    // 显示图表还是表格
    const showView = () => {
      return (
        <div className={styles.chartBox}>
          <ChartItemLoad
            loading={loading}
            option={option}
            loadOk={this.setChartList}
          />
        </div>
      )
    }

    return (<div className={styles.chart}>
      {/* 头部标题和样本量 */}
      <ChartTitle title={title}/> {/* 控制菜单 */}

      {/* 显示图表 */}
      {showView()}
    </div>)
  }
}

export default Chart
