import { Component } from 'react';
import styles from './index.scss';
import Loading from '_c/Chart/Loading';
import ChartItem from '_c/Chart/ChartItem';
import DownLoad from '_c/DownLoad';
import Select from '_c/Select';
import Option from '_c/Select/Option';
// import Table from 'antd/lib/table';
import { Radio, Input, Table } from 'antd';
const { Search } = Input;
const searchObj = {
    zh: '全标题搜索',
    en: 'Search',
    de: 'Suche',
}
class ChartPro extends Component {

    constructor(props) {
        super(props)
        this.chartDom = React.createRef();
        this.state = {
            showType: 'chart', // 显示图表还是表格
            chart: null, //
            filter: {},
            types: []
        }
    }

    handelFilter = (val) => {
        if (typeof val === 'string') { return; }
        let { filter } = this.state;
        if (val.key) {
            filter[val.key] = val;
        } else {
            Object.keys(val).forEach((key, i) => {
                filter[key] = val[key];
            });
        }
        const { filterChange } = this.props;
        filterChange({ ...filter });
    }

    handelType = (val) => {
        if (typeof val === 'string') { return };
        const { typeChange } = this.props;
        typeChange(val);
    }
    handelTypes = (val, index) => {
        if (typeof val === 'string') { return };
        const { typeChange } = this.props;
        let types = this.state.types;
        types[index] = val;
        this.props.types.forEach((titem, i) => {
            if (!types[i]) { types[i] = titem[0] }
        });
        this.setState({ types });
        typeChange(types);
    };

    setChartList = (chart) => {
        if (this.props.loadChartOK) {
            this.props.loadChartOK(chart);
        }

        this.setState({ chart: chart });
    }
    RadioChange = (val) => {
        this.handelFilter({ key: 'columnType', value: val.target.value });
    }
    searchChange = (val) => {
        this.handelFilter({ name: 'keyword', value: val, key: 'keyword' });
    }



    render() {
        const { loading,
            noDataImg,
            title,
            type,
            option,
            downTypes,
            filters,
            tags,
            conSearch,
            filter,
            downParam,
            children,
            chartStyle,
            pmark,
            onChange,
            columns,
            types,
            typeValue,
            pagination,
            sorterChange,
            otherDom,
            otherLayout,
            headerIndex,
            lang } = this.props;
        const index = headerIndex ? [...headerIndex] : null;
        const headerOrder = headerIndex ? index.reverse() : null;
        if (pagination && option) {
            pagination.total = option.total;
        }
        const showOther = () => {
            return React.cloneElement(this.props.otherDom);
        }
        //判断图表类型：chart(highchart图), children(传入自定义图表)，table（表格）
        const showView = () => {
            if (type === 'table') {
                return (
                    <Table
                        key={Math.random()}
                        bordered
                        align='center'
                        columns={columns}
                        dataSource={option.data}
                        size="middle"
                        onChange={sorterChange}
                        pagination={pagination ? pagination : false}
                    />)
            } else if (type === 'chart') {
                // const ch = React.Children.map(children, (item) => {
                //     if (item) {
                //         return React.cloneElement(item, {
                //             ...item.props,
                //             option: option,
                //             onChange: onChange,
                //         });
                //     } else {
                //         return null;
                //     }
                // });
                return (
                    <div
                        style={{ ...chartStyle }}
                        className={styles.chartBox}>
                        <ChartItem
                            style={{ height: '100%' }}
                            option={option}
                            loadOk={this.setChartList} />
                        {/* {ch !== null && ch} */}
                    </div>)
            } else if (type === 'children') {

                // if (typeof this.props.children === 'object') {
                //     return React.cloneElement(this.props.children, {
                //         ...this.props.children.props,
                //         option: option,
                //         onChange: onChange,
                //     });
                // }
                const drillChange = this.props.drillChange ? { drillChange: this.props.drillChange } : {};
                if (this.props.children) {
                    return (
                        <this.props.children
                            onChange={onChange}
                            {...option}
                            option={option}
                            {...drillChange}
                            filterChange={this.handelFilter}>
                        </this.props.children>)
                } else {
                    return (
                        <this.props.chartChildren
                            onChange={onChange}
                            {...option}
                            option={option}
                            {...drillChange}
                            filterChange={this.handelFilter}>
                        </this.props.chartChildren>)
                };
            } else if (type === 'childrenNode') {
                return React.cloneElement(this.props.children, {
                    ...this.props.children.props,
                    option: option,
                    onChange: onChange,
                });
            }
        }

        // types 不需要查询接口，切换条件
        const getTypes = () => {
            if (types[0] && types[0].title) {
                // typeValue
                let dft = types[0].title;
                if (typeValue && types[0]) {
                    typeValue.forEach((ty) => {
                        if (ty.key === types[0].key) {
                            dft = ty.title;
                        }
                    });
                }

                return (
                    <Select
                        style={{ float: 'right', marginRight: 8, width: 130 }}
                        size={'small'}
                        defaultFirst={true}
                        value={dft}
                        onChange={this.handelType}>
                        {types.map((item) => {
                            return (
                                <Option
                                    data-click={{
                                        type: `${item.key}-${item.value}`,
                                        title: `${item.key}`
                                    }}
                                    object={item}
                                    key={`${item.key}_${item.value}`}
                                    value={item.title}>
                                    {item.title}
                                </Option>)
                        })}
                    </Select>
                )
            } else {
                // typeValue
                return (
                    types.map((titem, i) => {
                        let dft = titem[0].title;
                        if (typeValue && types[0]) {
                            typeValue.forEach((ty) => {
                                if (ty.key === titem[0].key) {
                                    dft = ty.title;
                                }
                            });
                        }
                        return (<Select
                            style={{ float: 'right', marginRight: 8, width: 130 }}
                            size={'small'}
                            defaultFirst={true}
                            key={`${dft}_${i}`}
                            value={dft}
                            onChange={(val) => this.handelTypes(val, i)}>
                            {titem.map((item) => {
                                return (
                                    <Option
                                        data-click={{
                                            type: `${item.key}-${item.value}`,
                                            title: `${item.key}`
                                        }}
                                        key={`${item.key}_${item.value}`}
                                        object={item}
                                        value={item.title}>
                                        {item.title}
                                    </Option>)
                            })}
                        </Select>)
                    })
                )
            }

        }
        //filters [{},{}], {title: 'ff1', value: 1, key: 'ff1'}
        const getFilters = () => {
            if (filters && !filters.props) {

                return filters.map((fitem, i) => {
                    let val = fitem[0].title;
                    const valKey = fitem[0].key;
                    const { filterValue } = this.props;
                    if (filterValue) {
                        Object.keys(filterValue).forEach((key) => {
                            val = key === valKey ? filterValue[key].title : val;
                        });
                    }
                    return (
                        <Select
                            style={
                                {
                                    width: Math.max(...fitem.map((v) => (v.title || '').replace(/[\u4E00-\u9FA5]/g, '--').length)) / 2 + 2 + 'em',
                                    float: 'right', marginRight: 8
                                }
                            }
                            size={'small'}
                            value={val}
                            onChange={this.handelFilter}>
                            {fitem.map((item) => {
                                return (
                                    <Option
                                        data-click={{
                                            type: `${item.key}-${item.value}`,
                                            title: `${item.key}`
                                        }}
                                        object={item}
                                        value={item.title}>
                                        {item.title}
                                    </Option>)
                            })}
                        </Select>
                    )
                });
            } else {
                return filters
            }
        }
        const getTags = () => {
            return (
                <Radio.Group
                    defaultValue="a"
                    buttonStyle="solid"
                    onChange={this.RadioChange}
                    defaultValue={this.props.filterValue.columnType.value}
                    style={{ marginBottom: 8 }}>
                    {tags.map((item) => {
                        return (
                            <Radio.Button key={item.value} value={item.value}>
                                {item.title}
                            </Radio.Button>
                        )
                    })}
                </Radio.Group>)
        };
        const orderHeader = () => {
            return headerOrder.map((type) => {
                switch (type) {
                    case 'filters':
                        return getFilters();
                    case 'filter':
                        return filter;
                    case 'types':
                        return getTypes();
                }
            })
        }
        const noTitle = title === undefined || title === 'undefined' || title === 'false';
        const borderStyle = noTitle ? { border: 'none' } : {};
        const sConSty = tags ? { marginTop: 16 } : {};
        const hscon = downTypes ||
            conSearch ||
            filters ||
            filter ||
            types ||
            tags;
        return (
            <div
                style={{ ...this.props.style, ...borderStyle }}
                className={styles['car-chart-pro']}>
                <div className={`${styles['car-chart-h-con']}  ${styles[`car-h-con${this.props.titleType}`]}`}>
                    {/* 头部标题 */}
                    {!noTitle && <span className={styles[`item_header${this.props.titleType}`]} > {title}</span>}
                    {/* 筛选项和下载 */}
                    {
                        hscon &&
                        <div
                            className={styles['chart_s_con']}
                            style={{ ...sConSty }}>
                            {tags && getTags()}
                            {downTypes &&
                                <DownLoad
                                    {...downParam}
                                    types={downTypes}
                                    pmark={pmark}
                                    chart={this.state.chart !== null ? this.state.chart : this.chartDom}
                                    chartDom={this.chartDom}>
                                </DownLoad>}
                            {conSearch &&
                                <Search
                                    placeholder={searchObj[lang]}
                                    onSearch={this.searchChange}
                                    size="small"
                                    style={{ width: 200, float: 'right' }}
                                />}
                            {headerOrder === null && filters && getFilters()}
                            {headerOrder === null && filter && filter}
                            {headerOrder === null && types && getTypes()}
                            {headerOrder !== null && orderHeader()}
                        </div>
                    }
                </div>

                {/* Loading */}
                {
                    loading &&
                    <div className={styles['LoadingCon']} style={{ ...chartStyle }}>
                        <Loading />
                    </div>
                }
                {/* 暂无数据 */}
                {
                    !loading && option === null &&
                    <div className={styles['noData-pro']} style={{ ...chartStyle }}>
                        {noDataImg}
                        {!noDataImg && <p>暂无数据</p>}
                    </div>
                }

                {/* 图表 */}
                {
                    !loading && option && option !== -1 &&
                    <div ref={this.chartDom} style={{ ...chartStyle }}>
                        {otherDom && otherLayout === 'top' && showOther()}
                        {showView()}
                        {otherDom && otherLayout !== 'top' && showOther()}
                    </div>
                }
            </div >
        )
    }
}
ChartPro.defaultProps = {
    loading: true,
    option: -1,
    typeValue: [],
    lang: 'zh'
}
export default ChartPro