import React from "react";
import ChartItem from "_c/Chart/ChartItem";
import styles from "./index.scss";
import { Table } from "antd";
const TableType = ({ columns, option, sorterChange, pagination }) => {
  return (
    <Table
      key={Math.random()}
      bordered
      align="center"
      columns={columns}
      dataSource={option.data}
      size="middle"
      onChange={sorterChange}
      pagination={pagination ? pagination : false}
    />
  );
};

const ChartType = ({ option, setChartList }) => {
  return (
    <div className={styles.chartBox}>
      <ChartItem
        style={{ height: "100%" }}
        option={option}
        loadOk={setChartList}
      />
    </div>
  );
};

const ChildrenType = (props) => {
  const {
    option,
    children,
    onChange,
    drillChange,
    handelFilter,
    chartChildren,
    type,
  } = props;
  const dChange = drillChange ? { drillChange: drillChange } : {};
  if (type === "childrenNode") {
    return React.cloneElement(props.children, {
      ...props.children.props,
      option: option,
      onChange: onChange,
    });
  } else if (children) {
    return (
      <props.children
        onChange={onChange}
        {...option}
        option={option}
        {...dChange}
        filterChange={handelFilter}
      ></props.children>
    );
  } else {
    return (
      <props.chartChildren
        onChange={onChange}
        {...option}
        option={option}
        {...dChange}
        filterChange={handelFilter}
      ></props.chartChildren>
    );
  }
  // if (typeof children === 'object') {
  //   return React.cloneElement(children, {
  //     ...children.props,
  //     option: option,
  //     onChange: onChange,
  //   });
  // };
  // return (
  //   <children
  //     onChange={onChange}
  //     {...option}
  //     option={option}
  //     drillChange={drillChange || undefined}
  //     filterChange={handelFilter}>
  //   </children>
  // );
};

const typeIndex = {
  table: TableType,
  chart: ChartType,
  children: ChildrenType,
  childrenNode: ChildrenType,
};

const EleType = (props) => {
  const { type } = props;
  if (!typeIndex[type])
    return (
      <div>
        该{type}类型不支持，目前仅支持{Object.keys(typeIndex).join(",")}
      </div>
    );
  return typeIndex[type](props);
};

export default EleType;
