import { Component } from "react";
import styles from "./index.scss";
import Loading from "_c/Chart/Loading";
// import Table from 'antd/lib/table';
import EleType from "./EleType";
import Func from "./Func";
import { Radio, Input, Table } from "antd";
const { Search } = Input;

class ChartS extends Component {
  constructor(props) {
    super(props);
    this.chartDom = React.createRef();
    this.state = {
      showType: "chart", // 显示图表还是表格
      chart: null, //
      filter: {},
      types: [],
    };
  }

  handelFilter = (val) => {
    if (typeof val === "string") {
      return;
    }
    let { filter } = this.state;
    if (val.key) {
      filter[val.key] = val;
    } else {
      Object.keys(val).forEach((key, i) => {
        filter[key] = val[key];
      });
    }
    const { filterChange } = this.props;
    filterChange({ ...filter });
  };

  handelType = (val) => {
    if (typeof val === "string") {
      return;
    }
    const { typeChange } = this.props;
    typeChange(val);
  };
  handelTypes = (val, index) => {
    if (typeof val === "string") {
      return;
    }
    const { typeChange } = this.props;
    let types = this.state.types;
    types[index] = val;
    this.props.types.forEach((titem, i) => {
      if (!types[i]) {
        types[i] = titem[0];
      }
    });
    this.setState({ types });
    typeChange(types);
  };

  setChartList = (chart) => {
    if (this.props.loadChartOK) {
      this.props.loadChartOK(chart);
    }

    this.setState({ chart: chart });
  };
  RadioChange = (val) => {
    this.handelFilter({ key: "columnType", value: val.target.value });
  };
  searchChange = (val) => {
    this.handelFilter({ name: "keyword", value: val, key: "keyword" });
  };

  render() {
    const {
      loading,
      noDataImg,
      title,
      type,
      option,
      downTypes,
      filters,
      tags,
      conSearch,
      filter,
      downParam,
      children,
      chartStyle,
      pmark,
      onChange,
      columns,
      types,
      typeValue,
      pagination,
      sorterChange,
      otherDom,
      drillChange,
      filterValue,
      noHeader,
      mulFilter,
    } = this.props;
    if (pagination && option) {
      pagination.total = option.total;
    }
    const showOther = () => {
      return React.cloneElement(this.props.otherDom);
    };

    const noTitle =
      title === undefined || title === "undefined" || title === "false";
    const borderStyle = noTitle ? { border: "none" } : {};
    return (
      <div
        style={{ ...this.props.style, ...borderStyle }}
        className={styles["car-chart-pro"]}
      >
        <div
          className={`${styles["car-chart-h-con"]}  ${
            styles[`car-h-con${this.props.titleType}`]
          }`}
        >
          {/* 头部标题 */}
          {!noTitle && noHeader !== "noHeader" && (
            <span className={styles[`item_header${this.props.titleType}`]}>
              {" "}
              {title}
            </span>
          )}
          {/* 筛选项和下载 */}
          {noHeader !== "noHeader" && (
            <Func
              downTypes={downTypes}
              conSearch={conSearch}
              filters={filters}
              mulFilter={mulFilter}
              filter={filter}
              types={types}
              tags={tags}
              pmark={pmark}
              chartDom={this.chartDom}
              downChart={
                this.state.chart !== null ? this.state.chart : this.chartDom
              }
              downParam={downParam}
              searchChange={this.searchChange}
              RadioChange={this.RadioChange}
              filterValue={filterValue}
              handelFilter={this.handelFilter}
              handelType={this.handelType}
              handelTypes={this.handelTypes}
              typeValue={typeValue}
            />
          )}
        </div>

        {/* Loading */}
        {loading && (
          <div className={styles["LoadingCon"]} style={{ ...chartStyle }}>
            <Loading />
          </div>
        )}
        {/* 暂无数据 */}
        {!loading && option === null && (
          <div className={styles["noData-pro"]} style={{ ...chartStyle }}>
            {noDataImg}
            {!noDataImg && <p>暂无数据</p>}
          </div>
        )}

        {/* 图表 */}
        {!loading && option && option !== -1 && (
          <div
            className={styles.chartDom}
            ref={this.chartDom}
            style={{ ...chartStyle }}
          >
            <EleType
              type={type}
              columns={columns}
              sorterChange={sorterChange}
              pagination={pagination}
              option={option}
              children={children}
              onChange={onChange}
              drillChange={drillChange}
              setChartList={this.setChartList}
              handelFilter={this.handelFilter}
            />
          </div>
        )}
        {otherDom && showOther()}
      </div>
    );
  }
}
ChartS.defaultProps = {
  loading: true,
  option: -1,
  typeValue: [],
};
export default ChartS;
