import SelectMore from './SelectMore';

// uvnb国际化临时采用这种方式，后续需要使用react intl
const byMonth= localStorage.getItem("lang")=='en'?'By Month':'按月查看';

const dates = {
  day: '按日查看',
  week: '按周查看',
  month: byMonth,
  quarter: '按季度查看',
  year: '按年查看',
  halfYear: '按半年查看'
}

const Values = (props) => {
  const {
    size,
    select,
    dateType,
    value,
    close,
    describe,
    getword
  } = props;

  let type = select
    ? select
    : 'radio';

  const showLabs = () => {
    if (!describe) {
      let labs = dates[dateType]

      if(getword){
        labs = getword(labs)
      }
      return labs
    }
  }

  const showValue = (value)=>{
    if(getword){
      let reg = /至/g;
      if(reg.test(value)){
        let str = value.replace(reg, (item)=>{
          return getword(item)
        })
        return str
      }
    }
    return value
  }

  if ( type === 'radio' || type === 'section') {
    return (<span>
      <b>
        { showLabs() }
        { describe == true ? '' : <em>/</em> }
      </b>
      <b>{showValue(value)}</b>
    </span>)
  } else {
    return (
      <SelectMore
        labs={showLabs()}
        describe={describe}
        value={value}
        size={size}
        close={close}
      />
    )
  }

}
export default Values;
