import styles from '../styles.scss';
import Icon from '../../Icon';
import {Component} from 'react';
import moment from 'moment';

let halfTypes = ['H1', 'H2'];

class Jidu extends Component {
  constructor(props) {
    super(props)
    this.state = {
      year: ''
    }
  }

  componentDidMount() {
    let y;
    const {defaultValue} = this.props;
    if (defaultValue.length != '') {
      let temp = defaultValue
      temp = temp.split('H')
      let [y1] = temp;
      y = y1;
    } else {
      let dt = moment().quarter();
      if(dt > 2){
        y = moment().year()
      }else{
        y = moment().subtract(1, 'year').year()
      }
    }
    this.setState({year: `${y}年`})
  }

  // 年份增加
  addYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year++;
    this.setState({year: `${year}年`})
  }

  // 年份减少
  reduceYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year--;
    this.setState({year: `${year}年`})
  }

  render() {
    const {radioSelect, min, max, defaultValue} = this.props;

    let tempDate = defaultValue.split('H');
    let [ye, mon] = tempDate;

    const {year} = this.state;

    let flag = parseInt(year) == ye
      ? true
      : false;

    return (<div className={styles.right}>
      <div className={styles.top}>
        <Icon type={'zuofanye1'} clm={'car-color-hover__vi'} onClick={this.reduceYear}/>
        <div className={styles.selectDate}>
          <span>{year}</span>
        </div>
        <Icon type={'youfanye'} clm={'car-color-hover__vi'} onClick={this.addYear}/>
      </div>
      <div className={styles.conter}>
        <p>
          {
            halfTypes.map((item,i)=>{
              let dt = new Date();
              let nowY = parseInt(year);
              let nowM = ( i + 1)  * 6;
              let tempY = nowY

              let tempTiem = new Date(tempY, nowM, 0).getTime();

              let cls = '';
              let _act = '';
              if (flag && item == `H${mon}`) {
                cls = styles.active
                _act = 'car-bg__vi'
              }

              let tempValue = moment(`${tempY}-${nowM}`).endOf('month').format('YYYY-MM-DD')
              if (tempTiem > min && tempTiem < max) {
                return (<span key={i} className={`${cls} ${_act} car-bg-hover__vi`} onClick={radioSelect.bind(this, `${nowY}${item}`,tempValue)}>{item}</span>)
              } else {
                return (<span key={i} className={styles.noAble}>{item}</span>)
              }
            })
          }
        </p>
      </div>
    </div>)
  }
}

export default Jidu
