import styles from "../styles.scss";
import Icon from "../../Icon";
import { Component } from "react";
import moment from "moment";

let mzh = [
  ["01月", "02月", "03月"],
  ["04月", "05月", "06月"],
  ["07月", "08月", "09月"],
  ["10月", "11月", "12月"],
];
let men = [
  ["Jan", "Feb", "Mar"],
  ["Apr", "May", "Jun"],
  ["Jul", "Aug", "Sept"],
  ["Oct", "Nov", "Dec"],
];

let m = localStorage.getItem("lang") == "en" ? men : mzh;

const getTimes = (value, day) => {
  let temp = value.split("-");
  let [year, month] = temp;
  month = parseInt(month);

  let tempDate;
  if (day == 0) {
    tempDate = moment([year, month - 1]).startOf("month");
  } else {
    tempDate = moment([year, month - 1]).endOf("month");
  }

  return tempDate.valueOf();
};

const getTimsMax = (value, len = 0, max) => {
  let [_m, _n] = value.split("-");

  let _time = moment([_m, parseInt(_n) - 1])
    .add(len, "months")
    .endOf("month");

  let _temp = moment(max);

  let _value;
  let _qu = _temp.isAfter(_time);

  if (_qu) {
    _value = _time.valueOf();
  } else {
    _value = _temp.valueOf();
  }

  return _value;
};
const getTimsMin = (value, len = 0, min) => {
  let [_m, _n] = value.split("-");

  let _time = moment([_m, parseInt(_n) - 1])
    .subtract(len - 1, "months")
    .startOf("month");

  let _temp = moment(min);

  let _value;
  let _qu = _temp.isBefore(_time);

  if (_qu) {
    _value = _time.valueOf();
  } else {
    _value = _temp.valueOf();
  }

  return _value;
};

class Month extends Component {
  constructor(props) {
    super(props);
    let dt = new Date();
    let y = dt.getFullYear();
    this.state = {
      year: `${y}年`,
    };
  }

  componentDidMount() {
    const { defaultValue } = this.props;
    let y;
    if (defaultValue) {
      let temp = defaultValue.split("至")[0];
      let [y1] = temp.split("-");
      y = y1;
    } else {
      let dt = new Date();
      y = dt.getFullYear();
    }
    this.setState({ year: `${y}年` });
  }

  // 年份增加
  addYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year++;
    this.setState({ year: `${year}年` });
  };

  // 年份减少
  reduceYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year--;
    this.setState({ year: `${year}年` });
  };

  // 返回国际化
  getWords = (value) => {
    const { getword } = this.props;

    if (getword) {
      let reg = /年/g;

      if (reg.test(value)) {
        let str = value.replace(reg, "");
        return str;
      }

      return getword(value);
    }
    return value;
  };

  render() {
    const { sectionSelect, min, max, defaultValue, sectionNum } = this.props;

    let temp = defaultValue.split("至");
    const { year } = this.state;
    let beginTimes;
    let endTimes;

    let tempMin = min;
    let tempMax = max;
    if (temp.length > 1) {
      beginTimes = getTimes(temp[0], 1);
      endTimes = getTimes(temp[1], 0);
    } else {
      if (sectionNum && temp[0] != "") {
        tempMax = getTimsMax(temp[0], sectionNum, max);
        tempMin = getTimsMin(temp[0], sectionNum, min);
      }
    }

    return (
      <div className={styles.right}>
        <div className={styles.top}>
          <Icon
            type={"zuofanye1"}
            clm={"car-color-hover__vi"}
            onClick={this.reduceYear}
          />
          <div className={styles.selectDate}>
            <span>{this.getWords(year)}</span>
          </div>
          <Icon
            type={"youfanye"}
            clm={"car-color-hover__vi"}
            onClick={this.addYear}
          />
        </div>
        <div className={styles.conter}>
          {m.map((item, i) => {
            return (
              <p key={i}>
                {item.map((item1, j) => {
                  let _y = parseInt(year) + "";

                  let _time = moment(_y)
                    .month(parseInt(mzh[i][j]) - 1)
                    .endOf("month");

                  let nowY = _time.year();
                  let nowM = _time.month() + 1;

                  let tempTiem = _time.valueOf();

                  nowM = nowM <= 9 ? `0${nowM}` : nowM;

                  let cls = "";

                  let nowT = `${nowY}-${nowM}`;
                  let _act = "";

                  if (defaultValue.includes(nowT)) {
                    cls = styles.active;
                    _act = "car-bg__vi";
                  }

                  if (tempTiem > tempMin && tempTiem < tempMax) {
                    if (beginTimes && endTimes) {
                      let twoM = parseInt(mzh[i][j]);
                      let tempDay = new Date().getDate();
                      let nowTimeEnd = new Date(
                        nowY,
                        twoM - 1,
                        tempDay
                      ).getTime();
                      let nowTimeStart = new Date(nowY, twoM - 1, 1).getTime();

                      if (nowTimeStart > beginTimes && nowTimeEnd < endTimes) {
                        cls = styles.qujian;
                        return (
                          <span
                            className={`${cls} car-bg-hover__vi`}
                            key={j}
                            onClick={sectionSelect.bind(
                              this,
                              `${nowY}-${nowM}`
                            )}
                          >
                            {this.getWords(item1)}
                          </span>
                        );
                      } else {
                        return (
                          <span
                            className={`${cls} ${_act} car-bg-hover__vi`}
                            key={j}
                            onClick={sectionSelect.bind(
                              this,
                              `${nowY}-${nowM}`
                            )}
                          >
                            {this.getWords(item1)}
                          </span>
                        );
                      }
                    } else {
                      return (
                        <span
                          className={`${cls} ${_act} car-bg-hover__vi`}
                          key={j}
                          onClick={sectionSelect.bind(this, `${nowY}-${nowM}`)}
                        >
                          {this.getWords(item1)}
                        </span>
                      );
                    }
                  } else {
                    return (
                      <span key={j} className={styles.noAble}>
                        {this.getWords(item1)}
                      </span>
                    );
                  }
                })}
              </p>
            );
          })}
        </div>
      </div>
    );
  }
}

export default Month;
