import styles from '../styles.scss';
import Icon from '../../Icon';
import {Component} from 'react';

//获取第几周
const getWeek = (value) => {
  if (!value) return null
  let temp = value.split('至');
  let beginTime = temp[1].trim();

  let times = beginTime.split('-')
  let [year, month, day] = times;
  let count = 0;

  //获取该年的第一天是星期几
  let dayFirst = new Date(year, 0, 1).getDay();
  count += dayFirst;

  month = parseInt(month) - 1;
  for (let i = 1; i <= month; i++) {
    let tempDate = new Date(year, i, 0)
    let days = tempDate.getDate()
    count += parseInt(days)
  }

  count += parseInt(day) - 1;
  count = Math.ceil(count / 7);
  return `${year}年 第${count}周`
}

class Month extends Component {
  constructor(props) {
    super(props);

    this.state = {
      year: '',
      month: '',
      day: {
        before: [], //上个月日期
        current: [], // 当前月日期
        after: [] // 下个月日期
      }
    }
  }

  componentDidMount() {

    const {defaultValue} = this.props;
    let m;
    let y;

    if (defaultValue) {
      let temp = defaultValue.split('至')[0];
      let [y1, m1] = temp.split('-');
      m = parseInt(m1);
      y = parseInt(y1);
    } else {
      let dt = new Date();
      y = dt.getFullYear();
      m = dt.getMonth() + 1;
    }
    m = m <= 9
      ? `0${m}`
      : m;

    this.getDays(m, y)
  }

  // 年份增加
  addYear = async () => {
    let {month, year} = this.state;
    year = parseInt(year);
    year++;
    this.getDays(month, year)
  }

  // 年份减少
  reduceYear = async () => {
    let {month, year} = this.state;
    year = parseInt(year);
    year--;
    this.getDays(month, year)
  }

  // 增加月份
  addMonth = async (value) => {
    let {month, year} = this.state;
    month = parseInt(month);
    if (month >= 12) {
      month = 0;
      year = parseInt(year) + 1
    }
    month++;
    month = month <= 9
      ? `0${month}`
      : month;
    this.getDays(month, year)
  }

  // 减少月份
  reduceMonth = async () => {
    let {month, year} = this.state;
    month = parseInt(month);
    if (month <= 1) {
      month = 13;
      year = parseInt(year) - 1
    }
    month--;
    month = month <= 9
      ? `0${month}`
      : month;
    this.getDays(month, year)
  }

  // 获取日期
  getDays = (m, y) => {
    let month = m;
    let year = y;
    month = + month;
    year = + year;

    // 获取当前月 的 1 号是星期几
    let tempDate = new Date(year, month - 1, 1);
    tempDate = tempDate.getDay();
    tempDate = tempDate == 0
      ? 7
      : tempDate;

    let beforeList = []; // 上个月数组
    let currentList = []; // 当月数组
    let afterist = []; // 下个月数组

    // 获取上个月日期
    if (tempDate != 1) {
      // 设置为上个月最后一天
      let beforeDate = new Date(year, month - 1, 0);
      beforeDate = beforeDate.getDate();
      for (let i = 0; i < tempDate - 1; i++) {
        beforeList.push(beforeDate - i)
      }
      beforeList.reverse()
    }

    // 获取当月的日期
    let nowDate = new Date(year, month, 0);
    nowDate = nowDate.getDate();
    for (let i = 0; i < nowDate; i++) {
      currentList.push(nowDate - i)
    }
    currentList.reverse()

    // 获取下个月日期
    let len = 42 - currentList.length - beforeList.length;
    for (let i = 1; i < len + 1; i++) {
      afterist.push(i)
    }

    this.setState(() => {
      let temp = {
        before: beforeList, //上个月日期
        current: currentList, // 当前月日期
        after: afterist // 下个月日期
      }
      return {day: temp, year: y, month: m}
    })
  }

  render() {
    const {radioSelect, min, max, defaultValue} = this.props;
    const {year, month, day} = this.state;
    const {after, before, current} = day;
    let temp = [
      ...before,
      ...current,
      ...after
    ];

    let arr = []
    for (let i = 0; i < 6; i++) {
      let nowArr = temp.slice(i * 7, (i + 1) * 7)
      arr.push(nowArr)
    }

    let nowBeginTime = defaultValue.split('至');

    return (<div className={styles.right}>
      <div className={styles.top}>
        <Icon type={'zuofanye1'} clm={'car-color-hover__vi'} onClick={this.reduceYear}/>
        <Icon type={'zuofanye'} clm={'car-color-hover__vi'} onClick={this.reduceMonth}/>
        <div className={styles.selectDate}>
          <span>{year}年</span>
          <span>{month}月</span>
        </div>
        <Icon type={'youfanye1'} clm={'car-color-hover__vi'} onClick={this.addMonth}/>
        <Icon type={'youfanye'} clm={'car-color-hover__vi'} onClick={this.addYear}/>
      </div>
      <ul className={styles.conterWeek}>
        <li>
          <span>一</span>
          <span>二</span>
          <span>三</span>
          <span>四</span>
          <span>五</span>
          <span>六</span>
          <span>日</span>
        </li>
        {
          arr.map((item, i) => {

            let begin = item[0];
            let end = item[6];

            // 开始的天
            let BeginDay = begin <= 9
              ? `0${begin}`
              : begin;

            // 结束的天
            let endDay = end <= 9
              ? `0${end}`
              : end;

            // 开始时间
            let beginTime = `${year}-${month}-${BeginDay}`;

            // 结束时间
            let endTime = `${year}-${month}-${endDay}`;

            let tempMin = new Date(year, month - 1, begin).getTime();;
            let tempMax = new Date(year, month - 1, end).getTime();

            let flag = false; // 当前周是否可选

            // 判断上个月的情况
            if (i < 1 && begin > 7) {
              tempMin = new Date(year, month - 2, begin).getTime();
              let beginMonth = parseInt(month) - 1;
              let beginYear = year;
              if (beginMonth == 0) {
                beginMonth = 12;
                beginYear -= 1
              }

              beginMonth = beginMonth <= 9
                ? `0${beginMonth}`
                : beginMonth;
              beginTime = `${beginYear}-${beginMonth}-${BeginDay}`;
            }

            // 判断下个月情况开始时间
            if (i >= 4 && begin < 15) {
              tempMin = new Date(year, month, begin).getTime();
              let beginMonth = parseInt(month) + 1;
              let beginYear = year;

              if (beginMonth > 12) {
                beginMonth = 1;
                beginYear += 1
              }
              beginMonth = beginMonth <= 9
                ? `0${beginMonth}`
                : beginMonth;

              beginTime = `${beginYear}-${beginMonth}-${BeginDay}`;
            }

            // 判断下个月情况结束时间
            if (i >= 4 && end < 15) {
              tempMax = new Date(year, month, end).getTime();
              let endMonth = parseInt(month) + 1;
              let endYear = year;

              if (endMonth > 12) {
                endMonth = 1;
                endYear += 1
              }
              endMonth = endMonth <= 9
                ? `0${endMonth}`
                : endMonth;

              endTime = `${endYear}-${endMonth}-${endDay}`;
            }

            if (tempMin > min && tempMax < max) {
              flag = true;
            }

            let parmas = `${beginTime} 至 ${endTime}`

            let cls = styles.selectWeek;
            let _act = '';

            let discript = getWeek(parmas);
            if (nowBeginTime) {
              if(nowBeginTime[0] && nowBeginTime[1]){
                if (nowBeginTime[0].trim() == beginTime && nowBeginTime[1].trim() == endTime) {
                  cls = styles.active1;
                  _act = 'car-bg__vi'
                }
              }
            }

            if (flag) {
              return (<li key={i} className={`${cls} ${_act} car-bg-hover__vi`} onClick={radioSelect.bind(this, parmas, discript)}>
                {
                  item.map((num, j) => {
                    if (i < 1 && num > 7) {
                      return (<span className={styles.hui} key={j}>{num}</span>)
                    } else if (i >= 4 && num < 20) {
                      return (<span className={styles.hui} key={j}>{num}</span>)
                    } else {
                      return (<span key={j}>{num}</span>)
                    }
                  })
                }
              </li>)
            } else {
              return (<li key={i}>
                {
                  item.map((num, j) => {
                    return (<span className={styles.hui} key={j}>{num}</span>)
                  })
                }
              </li>)
            }
          })
        }
      </ul>
    </div>)
  }
}

export default Month
