// 单选
import DayRadio from './DayRadio';
import MonthRadio from './monthRadio';
import QuarterRadio from './quarterRadio';
import YearRadio from './yearRadio';
import WeekRadio from './WeekRadio';
import HalfYearRadio from './HalfYearRadio';
// 多选
import DayMulti from './DayMulti';
import MonthMulti from './monthMulti';
import QuarterMulti from './quarterMulti';
import YearMulti from './yearMulti';

// 区间
import DaySection from './DaySection';
import MonthSection from './MonthSection';
import WeekSection from './WeekSection';
import QuarterSection from './quarterSection';
import YearSection from './yearSection';

const Plus = (props) => {
  const {dateType, select} = props;

  switch (dateType) {
    case 'day':
      if (select === 'radio') {
        return (<DayRadio {...props}/>)
      } else if (select === 'mulit') {
        return (<DayMulti {...props}/>)
      } else if (select === 'section') {
        return (<DaySection {...props}/>)
      }
      break;
    case 'week':
      if (select === 'section') {
        return (<WeekSection {...props}/>)
      } else {
        return (<WeekRadio {...props}/>)
      }
      break;
    case 'month':
      if (select === 'radio') {
        return (<MonthRadio {...props}/>)
      } else if (select === 'mulit') {
        return (<MonthMulti {...props}/>)
      } else if (select === 'section') {
        return (<MonthSection {...props}/>)
      }
      break;
    case 'quarter':
      if (select === 'radio') {
        return (<QuarterRadio {...props}/>)
      } else if (select === 'mulit') {
        return (<QuarterMulti {...props}/>)
      } else if (select === 'section') {
        return (<QuarterSection {...props}/>)
      }
      break;
    case 'year':
      if (select === 'radio') {
        return (<YearRadio {...props}/>)
      } else if (select === 'mulit') {
        return (<YearMulti {...props}/>)
      } else if (select === 'section') {
        return (<YearSection {...props}/>)
      }
      break;
    case 'halfYear':
      return (<HalfYearRadio {...props}/>)
      break;
  }
};

export default Plus;
