import styles from '../styles.scss';
import Icon from '../../Icon';
import {Component} from 'react';

let mzh = [
  [
    '01月', '02月', '03月'
  ],
  [
    '04月', '05月', '06月'
  ],
  [
    '07月', '08月', '09月'
  ],
  [
    '10月', '11月', '12月'
  ]
]
let men = [
    [
        'Jan', 'Feb', 'Mar'
    ],
    [
        'Apr', 'May', 'Jun'
    ],
    [
        'Jul', 'Aug', 'Sept'
    ],
    [
        'Oct', 'Nov', 'Dec'
    ]
]

let m = localStorage.getItem("lang")=='en'? men : mzh;

class Month extends Component {
  constructor(props) {
    super(props);
    this.state = {
      year: ``
    }
  }

  componentDidMount() {

    let y;
    const {defaultValue} = this.props;
    let tempDate = defaultValue;
    if (typeof defaultValue == 'string') {
      tempDate = [tempDate]
    }

    if (tempDate.length > 1) {
      let temp = tempDate[0]
      temp = temp.split('-')
      let [y1] = temp;
      y = y1;
    } else {
      let dt = new Date();
      y = dt.getFullYear();
    }
    this.setState({year: `${y}年`})
  }

  // 年份增加
  addYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year++;
    this.setState({year: `${year}年`})
  }

  // 年份减少
  reduceYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year--;
    this.setState({year: `${year}年`})
  }

  render() {
    const {multiSelect, min, max, defaultValue} = this.props;
    const {year} = this.state;

    return (<div className={styles.right}>
      <div className={styles.top}>
        <Icon type={'zuofanye1'}  clm={'car-color-hover__vi'} onClick={this.reduceYear}/>
        <div className={styles.selectDate}>
          <span>{year}</span>
        </div>
        <Icon type={'youfanye'}  clm={'car-color-hover__vi'} onClick={this.addYear}/>
      </div>
      <div className={styles.conter}>
        {
          m.map((item, i) => {
            return (<p key={i}>
              {
                item.map((item1, j) => {

                  let nowY = parseInt(year);
                  let nowM = parseInt(mzh[i][j]);

                  let tempTiem = new Date(nowY, nowM - 1, 1).getTime();
                  let tempT = new Date(nowY, nowM - 1, 0).getDate();
                  let tempTiem_1 = new Date(nowY, nowM - 1, tempT).getTime();

                  nowM = nowM <= 9
                    ? `0${nowM}`
                    : nowM;

                  let cls = '';
                  let _act = '';

                  let nowT = `${nowY}-${nowM}`;

                  if (defaultValue.includes(nowT)) {
                    cls = styles.active
                     _act = 'car-bg__vi'
                  }

                  if (tempTiem > min && tempTiem_1 <= max) {
                    return (<span className={`${cls} ${_act} car-bg-hover__vi`} key={j} onClick={multiSelect.bind(this, `${nowY}-${nowM}`)}>{item1}</span>)
                  } else {
                    return (<span key={j} className={styles.noAble}>{item1}</span>)
                  }
                })
              }
            </p>)
          })
        }
      </div>
    </div>)
  }
}

export default Month
