import styles from '../styles.scss';
import Icon from '../../Icon';
import {Component} from 'react';
let q = ['Q1', 'Q2', 'Q3', 'Q4'];

class Jidu extends Component {
  constructor(props) {
    super(props)
    this.state = {
      year: ''
    }
  }

  componentDidMount() {
    let y;
    const {defaultValue} = this.props;
    let tempDate = defaultValue;
    if (typeof defaultValue == 'string') {
      tempDate = [tempDate]
    }
    if (tempDate.length > 1) {
      let temp = tempDate[0]
      temp = temp.split('Q')
      let [y1] = temp;
      y = y1;
    } else {
      let dt = new Date();
      y = dt.getFullYear();
    }
    this.setState({year: `${y}年`})
  }

  // 年份增加
  addYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year++;
    this.setState({year: `${year}年`})
  }

  // 年份减少
  reduceYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year--;
    this.setState({year: `${year}年`})
  }

  render() {
    const {multiSelect, min, max, defaultValue} = this.props;
    const {year} = this.state;

    return (<div className={styles.right}>
      <div className={styles.top}>
        <Icon type={'zuofanye1'} clm={'car-color-hover__vi'} onClick={this.reduceYear}/>
        <div className={styles.selectDate}>
          <span>{year}</span>
        </div>
        <Icon type={'youfanye'} clm={'car-color-hover__vi'} onClick={this.addYear}/>
      </div>
      <div className={styles.conter}>
        <p>
          {
            q.map((item, i) => {
              let dt = new Date();
              let nowY = parseInt(year);
              let nowM = (i + 1) * 3 - 1;
              dt.setFullYear(nowY);
              dt.setMonth(nowM);
              dt.setDate(1);
              let tempTiem = dt.getTime();

              let cls = '';
              let _act = '';
              let nowT = `${nowY}${item}`;

              if (defaultValue.includes(nowT)) {
                cls = styles.active
                _act = 'car-bg__vi'
              }
              if (tempTiem > min && tempTiem <= max) {
                return (<span key={i} className={`${cls} ${_act} car-bg-hover__vi`} onClick={multiSelect.bind(this, `${nowY}${item}`)}>{item}</span>)
              } else {
                return (<span key={i} className={styles.noAble}>{item}</span>)
              }
            })
          }
        </p>
      </div>
    </div>)
  }
}

export default Jidu
