import styles from '../styles.scss';
import Icon from '../../Icon';
import {Component} from 'react';

let q = ['Q1', 'Q2', 'Q3', 'Q4'];


const getTimes = (value, day) => {
  let temp = value.split('Q')

  let [year, month] = temp;
  month = parseInt(month) * 3  - 1;
  year = parseInt(year);

  let tempDay;
  if (day == 0) {
    tempDay = new Date(year, month + 1, 0).getDate();
  } else {
    tempDay = 1
  }
  let tempDate = new Date(year, month, tempDay).getTime()
  return tempDate
}

const getTimsMax = (value, len = 0, max) => {
  let temp = value.split('Q')
  let [y, m] = temp;
  m = parseInt(m) * 3 - 1;
  y = parseInt(y)
  let d = new Date(y, m + 1, 0).getDate();
  m += len

  if (m > 12) {
    m -= 12
    y++
  }
  let tempTime = new Date(y, m, d).getTime()
  tempTime = Math.min(tempTime, max)
  return tempTime
}
const getTimsMin = (value, len = 0, min) => {
  let temp = value.split('Q')
  let [y, m] = temp;
  m = parseInt(m) * 3 - 1;
  y = parseInt(y)
  let d = new Date(y, m + 1, 0).getDate();
  m -= len

  if (m < 1) {
    m += 12
    y--
  }
  let tempTime = new Date(y, m, d).getTime();
  tempTime = Math.max(tempTime, min)
  return tempTime
}

class Jidu extends Component {
  constructor(props) {
    super(props)
    let dt = new Date();
    let y = dt.getFullYear();
    this.state = {
      year: `${y}年`
    }
  }

  componentDidMount() {
    const {defaultValue} = this.props;
    let y;
    if (defaultValue) {
      let temp = defaultValue.split('至')[0];
      let [y1] = temp.split('Q');
      y = y1;
    } else {
      let dt = new Date();
      y = dt.getFullYear();
    }
    this.setState({year: `${y}年`})
  }

  // 年份增加
  addYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year++;
    this.setState({year: `${year}年`})
  }

  // 年份减少
  reduceYear = (value, e) => {
    let year = this.state.year;
    year = parseInt(year);
    year--;
    this.setState({year: `${year}年`})
  }

  render() {
    const { sectionSelect, min, max, defaultValue, sectionNum } = this.props;
    const { year } = this.state;

    let temp = defaultValue.split('至');
    let beginTimes;
    let endTimes;
    let tempMin = min;
    let tempMax = max;

    if (temp.length > 1) {
      beginTimes = getTimes(temp[0], 1)
      endTimes = getTimes(temp[1], 0)
    } else {
      if (sectionNum && temp[0] != '') {
        tempMax = getTimsMax(temp[0], sectionNum, max);
        tempMin = getTimsMin(temp[0], sectionNum, min);
      }
    }

    return (<div className={styles.right}>
      <div className={styles.top}>
        <Icon type={'zuofanye1'} clm={'car-color-hover__vi'} onClick={this.reduceYear}/>
        <div className={styles.selectDate}>
          <span>{year}</span>
        </div>
        <Icon type={'youfanye'} clm={'car-color-hover__vi'} onClick={this.addYear}/>
      </div>
      <div className={styles.conter}>
        <p>
          {
            q.map((item, i) => {
              let nowY = parseInt(year);
              let nowM = (i + 1) * 3 - 1;
              let nowD = new Date(nowY, nowM + 1, 0).getDate();
              let dt = new Date(nowY, nowM, nowD);
              let tempTiem = dt.getTime();
              nowM = nowM <= 9
                ? `0${nowM}`
                : nowM;

              let cls = '';
              let _act = '';
              let nowT = `${nowY}${item}`;

              if (defaultValue.includes(nowT)) {
                cls = styles.active
                _act = 'car-bg__vi'
              }
              if (tempTiem > tempMin && tempTiem < tempMax) {
                if (beginTimes && endTimes) {
                  let twoM = nowM;
                  let nowTimeStart = new Date(nowY, twoM, 1).getTime();
                  let nowTimeEnd = new Date(nowY, twoM, nowD).getTime();


                  if (nowTimeStart > beginTimes && nowTimeEnd < endTimes) {
                    cls = styles.qujian
                    return (
                      <span
                        className={`${cls} car-bg-hover__vi`}
                        key={i}
                        onClick={sectionSelect.bind(this, nowT)}
                      >
                        {item}
                      </span>
                    )
                  } else {
                    return (
                      <span
                        className={`${cls} ${_act} car-bg-hover__vi`}
                        key={i}
                        onClick={sectionSelect.bind(this, nowT)}
                      >
                        {item}
                      </span>
                    )
                  }
                } else {
                  return (
                    <span
                      key={i}
                      className={`${cls} ${_act} car-bg-hover__vi`}
                      onClick={sectionSelect.bind(this, nowT)
                      }
                    >
                      {item}
                    </span>
                  )
                }

              }else {
                return (<span key={i} className={styles.noAble}>{item}</span>)
              }

            })
          }
        </p>
      </div>
    </div>)
  }
}

export default Jidu
