import styles from '../styles.scss';
import Icon from '../../Icon';
import {Component} from 'react';

const getYearList = (min, max) => {
  let arr = [];
  let count = min - 1;
  for (let i = 1; i <= 4; i++) {
    let temp = []
    for (let j = 1; j <= 3; j++) {
      count++;
      temp.push(count)
    }
    arr.push(temp);
  }
  return arr
}

class Year extends Component {
  constructor(props) {
    super(props)
    let year = 2012;
    year = year - (year % 12);
    let nextYear = year + 11;
    let nowArr = getYearList(year, nextYear)
    this.state = {
      year: `${year}年 — ${nextYear}年`,
      yearValue: year,
      yearList: nowArr
    }
  }
  componentDidMount() {
    let nextYear;
    let nowArr;
    let year;
    const {defaultValue} = this.props;

    if (defaultValue.length != '') {
      let temp = defaultValue.split('-')
      let [y] = temp
      year = parseInt(y)
      year = year - (year % 12);
      nextYear = year + 11;
      nowArr = getYearList(year, nextYear)
    } else {
      year = 2012;
      nextYear = year + 11;
      nowArr = getYearList(year, nextYear)
    }

    this.setState({
      year: `${year}年 — ${nextYear}年`,
      yearValue: year,
      yearList: nowArr
    })
  }

  // 年份增加
  addYear = (value, e) => {
    let year = this.state.yearValue;
    year = parseInt(year) + 12;
    if (year > 2025)
      return
    let nextYear = parseInt(year) + 11;
    let nowArr = getYearList(year, nextYear)
    this.setState({year: `${year}年 — ${nextYear}年`, yearValue: year, yearList: nowArr})
  }

  // 年份减少
  reduceYear = (value, e) => {
    let year = this.state.yearValue;
    year = parseInt(year) - 12;
    if (year < 1990)
      year = 1990
    let nextYear = parseInt(year) + 11;
    let nowArr = getYearList(year, nextYear)
    this.setState({year: `${year}年 — ${nextYear}年`, yearValue: year, yearList: nowArr})
  }

  render() {
    const {radioSelect, min, max, defaultValue} = this.props;
    let tempDate = defaultValue.split('-');
    let [ye] = tempDate;

    const {year, yearList} = this.state;

    return (<div className={styles.right}>
      <div className={styles.top}>
        <Icon type={'zuofanye1'} clm={'car-color-hover__vi'} onClick={this.reduceYear}/>
        <div className={styles.selectDate}>
          <span>{year}</span>
        </div>
        <Icon type={'youfanye'} clm={'car-color-hover__vi'} onClick={this.addYear}/>
      </div>
      <div className={styles.conte1}>
        {
          yearList.map((item, i) => {
            return (<p key={i}>
              {
                item.map((item1, j) => {
                  let dt = new Date();
                  let nowY = parseInt(item1);
                  let minY = new Date(min).getFullYear()
                  let maxY = new Date(max).getFullYear()
                  let cls = '';
                  let _act = '';
                  if (ye == nowY) {
                    cls = styles.active
                    _act = 'car-bg__vi'
                  }
                
                  if (nowY >= minY && nowY < maxY) {
                    return (<span className={`${cls} ${_act} car-bg-hover__vi`} key={j} onClick={radioSelect.bind(this, `${nowY}`)}>{item1}</span>)
                  } else {
                    return (<span key={j} className={styles.noAble}>{item1}</span>)
                  }
                })
              }
            </p>)
          })
        }
      </div>
    </div>)
  }
}

export default Year
