import styles from '../styles.scss';
import Icon from '../../Icon';
import {Component} from 'react';

const getYearList = (min) => {
  let arr = [];
  let count = min - 1;
  for (let i = 1; i <= 4; i++) {
    let temp = []
    for (let j = 1; j <= 3; j++) {
      count++;
      temp.push(count)
    }
    arr.push(temp);
  }
  return arr
}


const getTimes = (value, day) => {
  let year = parseInt(value);

  if (day == 0) {
    return new Date(year + 1, 0, 0).getTime();
  } else {
    return new Date(year, 0, 1).getTime();
  }
}

const getTimsMax = (value, len = 0, max) => {
  let y = parseInt(value)
  let tempTime = new Date(y + len + 1, 0, 0).getTime();
  tempTime = Math.min(tempTime, max)
  return tempTime
}

const getTimsMin = (value, len = 0, min) => {
  let y = parseInt(value)
  let tempTime = new Date(y - len, 0, 1).getTime();
  tempTime = Math.max(tempTime, min)
  return tempTime
}

class Year extends Component {
  constructor(props) {
    super(props)
    let dt = new Date();
    let year = dt.getFullYear();
    year = year - (year % 12);
    let nextYear = year + 11;
    let nowArr = getYearList(year, nextYear)
    this.state = {
      year: `${year}年 — ${nextYear}年`,
      yearValue: year,
      yearList: nowArr
    }
  }

  componentDidMount() {
    const {defaultValue} = this.props;
    let year;

    if (defaultValue) {
      year = parseInt(defaultValue);
    }else{
      let dt = new Date();
      year = dt.getFullYear();
    }
    year = year - (year % 12);
    let nextYear = parseInt(year) + 11;
    let nowArr = getYearList(year, nextYear)

    this.setState({
      year: `${year}年 — ${nextYear}年`,
      yearValue: year,
      yearList: nowArr
    })
  }

  // 年份增加
  addYear = (value, e) => {
    let year = this.state.yearValue;
    year = parseInt(year) + 12;
    if (year > 2025)
      return
    let nextYear = parseInt(year) + 11;
    let nowArr = getYearList(year, nextYear)
    this.setState({year: `${year}年 — ${nextYear}年`, yearValue: year, yearList: nowArr})
  }

  // 年份减少
  reduceYear = (value, e) => {
    let year = this.state.yearValue;
    year = parseInt(year) - 12;
    if (year < 1990)
      year = 1990
    let nextYear = parseInt(year) + 11;
    let nowArr = getYearList(year, nextYear)
    this.setState({year: `${year}年 — ${nextYear}年`, yearValue: year, yearList: nowArr})
  }

  render() {
    const { sectionSelect, min, max, defaultValue, sectionNum } = this.props;
    const {year, yearList} = this.state;

    let temp = defaultValue.split('至');
    let beginTimes;
    let endTimes;
    let tempMin = min;
    let tempMax = max;

    if (temp.length > 1) {
      beginTimes = getTimes(temp[0], 1)
      endTimes = getTimes(temp[1], 0)
    } else {
      if (sectionNum && temp[0] != '') {
        tempMax = getTimsMax(temp[0], sectionNum, max);
        tempMin = getTimsMin(temp[0], sectionNum, min);
      }
    }

    return (<div className={styles.right}>
      <div className={styles.top}>
        <Icon type={'zuofanye1'} clm={'car-color-hover__vi'} onClick={this.reduceYear}/>
        <div className={styles.selectDate}>
          <span>{year}</span>
        </div>
        <Icon type={'youfanye'} clm={'car-color-hover__vi'} onClick={this.addYear}/>
      </div>
      <div className={styles.conte1}>
        {
          yearList.map((item, i) => {
            return (<p key={i}>
              {
                item.map((item1, j) => {

                  let nowY = parseInt(item1);
                  let tempTiem = new Date(nowY + 1, 0).getTime();
                  let cls = '';
                  let nowT = `${nowY}`;

                  let _act = '';

                  if (defaultValue.includes(nowY)) {
                    cls = styles.active
                    _act = 'car-bg__vi'
                  }


                  if (tempTiem > tempMin && tempTiem < tempMax) {

                    if (beginTimes && endTimes) {

                      let nowTimeEnd = new Date(nowY + 1, 0, 1).getTime();
                      let nowTimeStart = new Date(nowY, 0, 1).getTime();

                      if (nowTimeStart > beginTimes && nowTimeEnd < endTimes) {
                        cls = styles.qujian
                        return (
                          <span
                           className={`${cls} car-bg-hover__vi`}
                            key={j}
                            onClick={sectionSelect.bind(this, nowT)}
                          >
                            {item1}
                          </span>
                        )
                      } else {
                        return (
                          <span
                            className={`${cls} ${_act} car-bg-hover__vi`}
                            key={j}
                            onClick={sectionSelect.bind(this, nowT)}
                          >
                            {item1}
                          </span>
                        )
                      }
                    }else {
                      return (
                        <span
                          key={j}
                          className={`${cls} ${_act} car-bg-hover__vi`}
                          onClick={sectionSelect.bind(this, nowT)
                          }
                        >
                          {item1}
                        </span>
                      )
                    }
                  } else {
                    return (
                      <span
                        key={j}
                        className={styles.noAble}
                      >
                        {item1}
                      </span>
                    )
                  }

                })
              }
            </p>)
          })
        }
      </div>
    </div>)
  }
}

export default Year
