
import moment from 'moment';
const diffMonth = (start, end) => {
    const sm = moment(start);
    const em = moment(end);
    const diffYear = (em.format('YYYY') - sm.format('YYYY')) * 12;
    const diffMonth = em.format('M') - sm.format('M');
    return diffYear + diffMonth;
};
const getQuarter = (selectType, sectionNum, limit) => {
    let serverDate = new Date();
    const sh = serverDate.getHours();
    const sd = serverDate.getDate();
    let quarter = ''; // 季度
    let quarterS = '';
    let mStart = new Date();
    if (sd === 1 && sh < 8) {
        const sd = limit === 1 ? moment(mStart).subtract(2, 'quarter') : moment(mStart).subtract(limit, 'quarter'); ///.quarter();
        const ed = moment(mStart).subtract(sectionNum + (limit === 1 ? 2 : limit), 'quarter'); //.quarter();
        quarter = `${sd.year()}Q${sd.quarter()}`;
        quarterS = `${ed.year()}Q${ed.quarter()}`;
    } else {
        const sd = moment(mStart).subtract(limit, 'quarter');
        const ed = moment(mStart).subtract(sectionNum, 'quarter');
        quarter = `${sd.year()}Q${sd.quarter()}`;
        quarterS = `${ed.year()}Q${ed.quarter()}`;
    }
    if (selectType === 'section') {
        return `${quarterS} 至 ${quarter}`;
    } else {
        return quarter;
    }
};
const getYear = (selectType, sectionNum, limit) => {
    let ys = new Date();
    let ye = new Date();
    ys.setFullYear(ys.getFullYear() - limit);
    ye.setFullYear(ys.getFullYear() - sectionNum + 1);
    if (selectType === 'section') {
        return `${moment(ye).format('YYYY')} 至 ${moment(ys).format('YYYY')}`;
    } else {
        return moment(ys).format('YYYY');
    }
};

const getMonth = (selectType, sectionNum, limit) => {
    const serverDate = new Date();
    const sh = serverDate.getHours();
    const sd = serverDate.getDate();
    let monthEnd = new Date();
    // 8点以后更新
    if (sd === 1 && sh < 8) {
        monthEnd.setMonth(monthEnd.getMonth() - limit - 1);
    } else if (sd === 2 && sh < 8) {
        monthEnd.setMonth(monthEnd.getMonth() - limit - 1);
    } else {
        monthEnd.setDate(1);
        monthEnd.setMonth(monthEnd.getMonth() - limit);
    }
    if (selectType === 'section') {
        let monthStart = new Date();
        monthStart.setDate(1);
        monthStart.setMonth(monthStart.getMonth() - limit - sectionNum + 1);
        return `${moment(monthStart).format('YYYY-MM')} 至 ${moment(monthEnd).format('YYYY-MM')}`;
    } else {
        return moment(monthEnd).format('YYYY-MM');
    }
};
const getWeek = (selectType, sectionNum, limit) => {
    const serverDate = new Date();
    const sh = serverDate.getHours();
    const sw = serverDate.getDay();
    let week = '';
    let weeks = '';
    let wd = moment();
    let wds = moment();
    if (sw === 1 && sh < 8) {
        wd = moment(serverDate).subtract(limit, 'week');
        wds = moment(serverDate).subtract(sectionNum, 'week');
    } else {
        wd = moment(serverDate).subtract(limit, 'week');
        wds = moment(serverDate).subtract(sectionNum, 'week');
    }
    const monday = moment().day("Monday").year(wd.year()).week(wd.week());
    const sunday = new Date(monday.format('YYYY-MM-DD'));
    const mondays = moment().day("Monday").year(wds.year()).week(wds.week());
    sunday.setDate(sunday.getDate() + 6);
    week = `${monday.format('YYYY-MM-DD')} 至 ${moment(sunday).format('YYYY-MM-DD')}`;
    weeks = `${mondays.format('YYYY-MM-DD')} 至 ${moment(sunday).format('YYYY-MM-DD')}`;
    if (selectType === 'section') {
        return weeks;
    }
    else {
        return week;
    }
};
const getDay = (selectType, sectionNum, limit) => {
    const serverDate = new Date();
    const day = moment(serverDate).subtract(limit, 'days');
    const days = moment(serverDate).subtract(sectionNum + limit - 1, 'days');
    if (selectType === 'section') {
        return `${days.format('YYYY-MM-DD')} 至 ${day.format('YYYY-MM-DD')}`
    }
    else {
        return day.format('YYYY-MM-DD');
    }
}

const getMax = () => {
    return moment(new Date()).format('YYYY-MM-DD');
};

const getHalfYear = (val) => {
    let tempDate = val ? new Date(val) : new Date();
    let year = tempDate.getUTCFullYear(); // 年
    let month = tempDate.getMonth() + 1; // 月
    let halfYear = '';
    let startMonth = '';
    let endMonth = '';
    if (month > 6) {
        halfYear = `${year}H1`;
        startMonth = `${year}-01-01`;
        endMonth = `${year}-06-30`;
    } else {
        halfYear = `${year - 1}H2`;
        startMonth = `${year - 1}-07-01`;
        endMonth = `${year - 1}-12-31`;
    }
    return halfYear;
};

const getDates = (date, type) => {

    let startDate = '';
    let endDate = '';
    if (type === 3) {
        let monthStart = new Date(date);
        monthStart.setDate(1);
        let monthEnd = new Date(date);
        monthEnd.setMonth(monthEnd.getMonth() + 1);
        monthEnd.setDate(0);
        startDate = moment(monthStart).format('YYYY-MM-DD');
        endDate = moment(monthEnd).format('YYYY-MM-DD');
    }
    else if (type === 2) {
        let QTime = {
            Q1: ['-01-01', '-03-31'],
            Q2: ['-04-01', '-06-30'],
            Q3: ['-07-01', '-09-30'],
            Q4: ['-10-01', '-12-31'],
        };
        startDate = date.replace(/(Q\d)/, match => QTime[match][0]);
        endDate = date.replace(/(Q\d)/, match => QTime[match][1]);
    }
    else if (type === 1) {
        let ys = new Date(date);
        let ye = new Date(date);
        let smonth = ys.setMonth(2);
        let emonth = ye.setMonth(13);
        const start = getMonth(moment(smonth).format('YYYY-MM'), 3);
        const end = getMonth(moment(emonth).format('YYYY-MM'), 3);
        startDate = start.startDate;
        endDate = end.endDate;
    } else if (type === 6) {
        let HTime = {
            H1: ['-01-01', '-06-30'],
            H2: ['-07-01', '-12-31'],
        };
        startDate = date.replace(/(H\d)/, match => HTime[match][0]);
        endDate = date.replace(/(H\d)/, match => HTime[match][1]);
    }
    return { startDate, endDate };
};

const getDefaultDate = (type, selectType, sectionNum, limit) => {
    switch (type) {
        case 'month':
            return getMonth(selectType, sectionNum, limit);
            break;
        case 'quarter':
            return getQuarter(selectType, sectionNum, limit);
            break;
        case 'year':
            return getYear(selectType, sectionNum, limit);
            break;
        case 'week':
            return getWeek(selectType, sectionNum, limit);
            break;
        case 'day':
            return getDay(selectType, sectionNum, limit);
            break;
    }

};


export default {
    getDefaultDate: getDefaultDate,
    getDates: getDates,
    getMonth,
    getMax,
    diffMonth,
};
