import { Component } from 'react';
import DatePick from '_c/Date';
import formatUtil from './formatUtil';
import moment from 'moment';
class DatePro extends Component {
    constructor(props) {
        super(props);
        const { defaultType, select, limit, selectLength } = this.props;
        const df = formatUtil.getDefaultDate(defaultType, select, selectLength, limit[defaultType]);
        const max = moment().format('YYYY-MM-DD');
        this.state = {
            testDateType: df,
            max,
        }
    }

    typeChange = (value) => {
        const { select, onChange, sectionNum, limit } = this.props;
        let val = formatUtil.getDefaultDate(value, select, sectionNum, limit[value]);
        this.setState({ testDateType: val });
        onChange(val);
    }

    selectChange = (val) => {
        this.setState({ testDateType: val });
        this.props.onChange(val);
    }

    render() {
        const { testDateType, max } = this.state;
        const { selectType, defaultType, sectionNum, select, style } = this.props;
        return (<DatePick
            select={select}
            jumpYear
            inputStyle={{ ...style }}
            direction='left'
            sectionNum={sectionNum}
            placehold='选择日期'
            selectType={selectType}
            defaultValue={testDateType}
            min='2016-05-01'
            max={max}
            dType={defaultType}
            typeChage={this.typeChange}
            onChange={this.selectChange} />)
    }
}

DatePro.defaultProps = {
    selectType: ['year', 'quarter', 'month', 'week', 'day'],
    defaultType: 'week',
    sectionNum: 3,
    select: 'section',
    limit: 1,
    min: '',
    selectLength: 1
}
export default DatePro;