import styles from './style.scss';
import Arrow from './arrow';
import Chart from './chart';

const Loss = ({data={}}) => {
  const {
    lossAnalysis,
    interestCmpTop10, // 兴趣
    intentCmpTop10, // 意向
    remainCmpTop10 // 重合度
  } = data;

  if(!lossAnalysis || !interestCmpTop10 || !intentCmpTop10 || !remainCmpTop10) {
    return (
      <div className={styles['nowData']}>
        <p>暂无数据</p>
      </div>
    )
  }

  return (
    <div className={styles['car-loss-box']}>
      <div className={styles['loss']}>

      <div className={styles['level-1']}>
        <div className={styles['level-conter']}
          style={{background: '#1CA1FF', margin: '0'}}>
          <p>关注用户</p>
          <p>{parseInt(lossAnalysis[0][0].value).toLocaleString()}（{lossAnalysis[0][0].rank}）</p>
        </div>
      </div>

      <div className={styles['level-2']}>
        <Arrow type/>
      </div>
      <div className={styles['level-2']}>
        <div className={styles['level-left']} style={{background: '#A7DE02'}}>
          <Chart title='流失去向Top10车型' data={interestCmpTop10}/>
          <p>仅竞品兴趣用户</p>
          <p>{parseInt(lossAnalysis[1][0].value).toLocaleString()}（{lossAnalysis[1][0].rank}）</p>
        </div>
        <div className={styles['level-conter']} style={{background: '#4CBCFF'}}>
          <p>本品兴趣用户</p>
          <p>{parseInt(lossAnalysis[1][1].value).toLocaleString()}（{lossAnalysis[1][1].rank}）</p>
        </div>
        <div className={styles['level-right']} style={{background: '#36D5A8'}}>
          <p>流失用户</p>
          <p>{parseInt(lossAnalysis[1][2].value).toLocaleString()}（{lossAnalysis[1][2].rank}）</p>
        </div>
      </div>


      <div className={styles['level-3']}>
        <Arrow type/>
      </div>
      <div className={styles['level-3']}>
        <div className={styles['level-left']} style={{background: '#A7DE02'}}>
          <Chart title='流失去向Top10车型' data={intentCmpTop10}/>
          <p>仅竞品意向用户</p>
          <p>{parseInt(lossAnalysis[2][0].value).toLocaleString()}（{lossAnalysis[2][0].rank}）</p>
        </div>
        <div
        className={styles['level-conter']}
        style={{background: '#80CFFF',minWidth:200}}>
          <p>本品意向用户</p>
          <p>{parseInt(lossAnalysis[2][1].value).toLocaleString()}（{lossAnalysis[2][1].rank}）</p>
        </div>

        <div
        className={styles['level-right']}
        style={{background: '#36D5A8'}}>
          <p>流失用户</p>
          <p>{parseInt(lossAnalysis[2][2].value).toLocaleString()}（{lossAnalysis[2][2].rank}）</p>
        </div>
      </div>

      <div
      className={styles['level-4']}
      style={{minWidth: 310,margin: '0 auto 0 360px'}}>
        <Arrow />
      </div>
      <div className={styles['level-4']}>
        <div
        className={styles['level-conter']}
        style={{background: '#FB9500', marginRight: '0', marginLeft: '0'}}>

          <p>仅本品留资用户</p>
          <p>{parseInt(lossAnalysis[3][0].value).toLocaleString()}（{lossAnalysis[3][0].rank}）</p>

        </div>
        <div
        className={styles['level-conter']}
        style={{background: '#FB9500', marginRight: '0'}}>

          <Chart title='意向重合度Top10车型' data={remainCmpTop10}/>
          <p>本竞品留资用户</p>
          <p>{parseInt(lossAnalysis[3][1].value).toLocaleString()}（{lossAnalysis[3][1].rank}）</p>

        </div>
      </div>
    </div>
  </div>
    
  )
}

export default Loss
