import styles from './style.scss';

const COLORS = ['#FF5500','#FAAD14', '#52C41A'];

const Chart = (props) => {

  const {title, data} = props;

  return (
    <div className={styles['chart']}>
      <div className={styles['chart-title']}>{title}</div>
      {
        data.map((item, i)=>{
          let color = '';
          if(i < 3){
            color = COLORS[i];
          }
          let rank = i + 1;
          rank = rank > 9 ? `${rank}` : `0${rank}`;

          return (
            <div className={styles['rank']}>
              {/*  排名 */}
              <span
                className={styles['rank-num']}
                style={{color: color}}
              >
                {rank}
              </span>

              {/*  车名 */}
              <span className={styles['name']} title={item.seriesName}>
                {item.seriesName}
              </span>

              {/*  百分比 */}
              <span className={styles['per']} title={`${item.num}%`}>
                {`${item.num}%`}
              </span>
            </div>
          )
        })
      }
    </div>
  )
}

export default Chart
