import styles from "./style.scss";
import Arrow from "./arrow";
import Chart from "./chart";

const Loss = ({ data = {} }) => {
  const {
    lossAnalysis,
    interestCmpTop10, // 兴趣
    intentCmpTop10, // 意向
    remainCmpTop10 // 重合度
  } = data;

  if (
    !lossAnalysis ||
    !interestCmpTop10 ||
    !intentCmpTop10 ||
    !remainCmpTop10
  ) {
    return (
      <div className={styles["nowData"]}>
        <p>暂无数据</p>
      </div>
    );
  }

  return (
    <div className={styles["car-loss-new-box"]}>
      <div className={styles["loss"]}>
        <div className={styles["level-1"]}>
          <div
            className={styles["level-conter"]}
            style={{ background: "#1CA1FF", margin: "0" }}
          >
            <div className={styles["level-conter-item"]}>
              <p>关注用户</p>
              <p>
                {parseInt(lossAnalysis[0][0].value).toLocaleString()}（
                {lossAnalysis[0][0].rank}）
              </p>
            </div>
          </div>
        </div>

        <div className={styles["level-2"]}>
          <Arrow type />
        </div>
        <div className={styles["level-2"]}>
          <div
            className={styles["level-left"]}
            style={{ background: "#A7DE02" }}
          >
            <Chart title="流失去向Top10车型" data={interestCmpTop10} />
            <p>仅竞品兴趣用户</p>
            <p>
              {parseInt(lossAnalysis[1][0].value).toLocaleString()}（
              {lossAnalysis[1][0].rank}）
            </p>
          </div>
          <div
            className={styles["level-conter"]}
            style={{ background: "#4CBCFF" }}
          >
            <div className={styles["level-conter-item"]}>
              <p>仅本品兴趣用户</p>
              <p>
                {parseInt(lossAnalysis[1][1].value).toLocaleString()}（
                {lossAnalysis[1][1].rank}）
              </p>
            </div>

            <div className={styles["level-conter-item"]}>
              <p>本竞品 重合兴趣用户</p>
              <p>
                {parseInt(lossAnalysis[1][2].value).toLocaleString()}（
                {lossAnalysis[1][2].rank}）
              </p>
            </div>
          </div>
          <div
            className={styles["level-right"]}
            style={{ background: "#36D5A8" }}
          >
            <p>流失用户</p>
            <p>
              {parseInt(lossAnalysis[1][3].value).toLocaleString()}（
              {lossAnalysis[1][3].rank}）
            </p>
          </div>
        </div>

        <div className={styles["level-3"]}>
          <Arrow type />
        </div>
        <div className={styles["level-3"]}>
          <div
            className={styles["level-left"]}
            style={{ background: "#A7DE02" }}
          >
            <Chart title="流失去向Top10车型" data={intentCmpTop10} />
            <p>仅竞品线索</p>
            <p>
              {parseInt(lossAnalysis[2][0].value).toLocaleString()}（
              {lossAnalysis[2][0].rank}）
            </p>
          </div>
          <div
            className={styles["level-conter"]}
            style={{ background: "#80CFFF", minWidth: 200 }}
          >
            <div className={styles["level-conter-item"]}>
              <p title='本品线索用户'>仅本品线索</p>
              <p>
                {parseInt(lossAnalysis[2][1].value).toLocaleString()}（
                {lossAnalysis[2][1].rank}）
              </p>
            </div>

            <div className={styles["level-conter-item"]}>
              <Chart title="线索重合度Top10车型" data={remainCmpTop10} />
              <p title='本竞品重合线索用户'>本竞品重合线索</p>
              <p>
                {parseInt(lossAnalysis[2][2].value).toLocaleString()}（
                {lossAnalysis[2][2].rank}）
              </p>
            </div>
          </div>

          <div
            className={styles["level-right"]}
            style={{ background: "#36D5A8" }}
          >
            <p>流失用户</p>
            <p>
              {parseInt(lossAnalysis[2][3].value).toLocaleString()}（
              {lossAnalysis[2][3].rank}）
            </p>
          </div>
        </div>

        <div
          className={styles["level-4"]}
          style={{ minWidth: 310, margin: "0 auto 0 360px" }}
        ></div>
      </div>
    </div>
  );
};

export default Loss;
