import React, { Component } from 'react'
import PropTypes from 'prop-types'
import styles from './index.scss'
import Icon from './../Icon'
class MenuItem extends Component {
  constructor(props, content) {
    super(props);
    this.toggleActive = this.toggleActive.bind(this);
    this.state = {
      active: false
    }
  }
  toggleActive() {
    if (this.props.url == '/#') {
      return false;
    };
    this.props.resetActiveKey(this.props.val)
  }

  render() {
    const children = this.props.children;
    const padNum2 = 46;
    const padNum3 = 62;
    let padNum = this.props.level == 3
      ? padNum2
      : padNum3;

    padNum = this.props.level == 2
      ? 20
      : padNum;
    const padStyle = {
      paddingLeft: padNum + 'px'
    };
    const activeCls = this.props.val == this.props.activeItem
      ? 'car-menu-item-active'
      : 'car-menu-item-noactive'
    return (<li className={`${styles['car-menu-item']} ${styles[activeCls]} `} style={padStyle} onClick={this.toggleActive}>
      {this.props.icon && <Icon type={this.props.icon} clm={styles['menu-title-icon']}></Icon>}
      {children}
    </li>)
  }
}

export default MenuItem;
