import React, { Component } from 'react'
import PropTypes from 'prop-types'
import styles from './index.scss'
import Icon from './../Icon'
class SubMenu extends Component {
  constructor(props, content) {
    super(props);
    this.toggleActive = this.toggleActive.bind(this);
    this.handleActiveSub = this.handleActiveSub.bind(this);
    this.state = {
      open: false,
      activeSubItem: ''
    }
  }
  async toggleActive(e) {
    if (this.props.activeSub.indexOf(this.props.val) !== -1) {
      let na = [];
      await this.props.activeSub.forEach((val, index) => {
        if (val !== this.props.val) {
          na.push(val);
        }
      });
      this.props.resetActiveSub(na);
    } else {
      this.props.resetActiveSub([this.props.val]);
    }

  }
  componentWillMount() {
    // if (this.props.defaultActiveSub && this.props.defaultActiveSub.indexOf(this.props.val) !== -1) {
    //   this.props.resetActiveSub([this.props.val]);
    // }
    this.setState({ 'activeSub': this.props.defaultActiveSub, 'activeKey': this.props.defaultActiveItem });
  }
  handleActiveSub = (val) => {
    this.setState({ 'activeSubItem': val })
  }
  render() {
    const children = this.props.children;
    const hiddenCls = this.props.activeSub.indexOf(this.props.val) !== -1
      ? 'car-menu-active'
      : 'car-menu-hidden'
    const arrowCls = this.props.activeSub.indexOf(this.props.val) == -1
      ? 'car-arrow-slid'
      : 'car-arrow-open'
    const padNum2 = 20;
    const padNum3 = 46;
    const padNum = this.props.level == 2
      ? padNum2
      : padNum3;
    const padStyle = {
      paddingLeft: padNum + 'px'
    };
    const items = React.Children.map(children, (item) => {
      if (item.props.children instanceof Array) {
        return React.cloneElement(item, {
          activeSub: this.state.activeSubItem,
          level: this.props.level + 1,
          resetActiveSub: this.handleActiveSub,
          activeItem: this.props.activeKey,
          resetActiveKey: this.props.resetActiveKey,
          activeKey: this.props.activeKey,
          defaultActiveSub: this.props.defaultActiveSub
        })
      } else {
        return React.cloneElement(item, {
          activeItem: this.props.activeKey,
          level: this.props.level + 1,
          activeKey: this.props.activeKey,
          resetActiveKey: this.props.resetActiveKey
        })
      }

    })
    return (<li className={styles['car-menu-sub']}>
      <div style={padStyle} className={styles['car-menu-sub-title']} onClick={(e) => this.toggleActive(e)}>
        {this.props.icon && <Icon type={this.props.icon} clm={styles['menu-title-icon']}></Icon>}

        <span className={styles['menu-title']}>{this.props.title}</span>
        {items && <Icon type={'xiala'} clm={`${styles['menu-arrow-icon']} ${styles[arrowCls]}`}></Icon>}

      </div>
      <ul className={`${styles['car-menu-sub-con']} ${styles[hiddenCls]}`}>
        {items}
      </ul>
    </li>)
  }
}
export default SubMenu;
