import React, {Component} from 'react'
import PropTypes from 'prop-types'
import styles from './index.scss'
import SubMenu from './SubMenu.js'
class Menu extends Component {

  constructor(props, content) {
    super(props);
    this.handleActive = this.handleActive.bind(this);
    this.handleActiveItem = this.handleActiveItem.bind(this)
    this.state = {
      activeSub: 'k1',
      activeKey: ''
    }
  }

  handleActive(val) {
    this.setState({'activeSub': val})
  }
  handleActiveItem(val) {
    this.setState({'activeKey': val})
  }
  componentWillMount() {
    this.setState({'activeSub': this.props.defaultActiveSub, 'activeKey': this.props.defaultActiveItem});
  }
  componentWillReceiveProps(nextProps) {
    this.setState({'activeSub': nextProps.defaultActiveSub, 'activeKey': nextProps.defaultActiveItem});
  }
  change() {
  }

  render() {
    const children = this.props.children;
    const subList = React.Children.map(children, (item) => {
      return React.cloneElement(item, {
        activeSub: this.state.activeSub,
        resetActiveSub: this.handleActive,
        activeItem: this.state.activeKey,
        level: 2,
        activeKey: this.state.activeKey,
        resetActiveKey: this.handleActiveItem,
        defaultActiveSub: this.props.defaultActiveSub
      })
    })
    return (
      <div className={styles['car-default']}>
        <div className={styles['car-menu']}>
          <ul className={`${styles['car-menu-sub-list']}`}>
            {subList}
          </ul>
        </div>
      </div>
    )
  }
}
export default Menu;
