import React, { Component } from 'react'
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types'
import styles from './index.scss'
import Icon from './../Icon'
import SubWrap from './ColSubWrap'
class ColSubMenu extends Component {
  constructor(props, content) {
    super(props);
    this.el = document.createElement('div');
    this.subREF = React.createRef();
    this.state = {
      open: false,
      subOverOn: false,
      hh: 0,
      onLevel: 0,
      onVal: 0
    }
  }

  subOver = (e, level, onVal) => {
    e.stopPropagation();
    const { onSubOver } = this.props;
    this.setState({ subOverOn: true, onLevel: level, onVal });
    onSubOver(e, level, onVal);
  }

  subOut = (e, level, val) => {
    e.stopPropagation();
    const { collapsed, onSubLeave } = this.props;
    if (level != this.state.onLevel) return false;
    setTimeout(() => {
      if (level == this.state.onLevel) {
        this.setState({ subOverOn: false });
        onSubLeave(e, level);
      }
    }, 300);
  }

  toggleActive = (e, val) => {
    this.props.resetActiveSub([this.props.subVal]);
    this.props.resetActiveKey(val);
  }

  render() {
    const { items, style, onSubOver, onSubLeave, level: sLevel, top, title: mtitle } = this.props;
    return (
      <ul
        className={styles['car-menu-sub-col']}
        style={{ ...style }}
        onMouseOver={onSubOver}
        onMouseLeave={onSubLeave}>
        {mtitle && <li style={{ fontSize: 16, fontWeight: 'bolder' }}>{mtitle}</li>}
        {items.map((munuItem, i) => {
          const { activeItem, children, level, val, title } = munuItem.props;
          const activeCls = this.props.activeKey == val
            ? 'car-menu-item-active'
            : 'car-menu-item-noactive'
          const key = munuItem.key;
          if (!(children instanceof Array)) {
            return (<li
              className={styles[activeCls]}
              key={val}
              onClick={(e, v) => this.toggleActive(e, val)}>
              {children}
            </li>)
          } else {
            return (<li
              key={val}
              ref={this.subREF}
              onMouseOver={(e, l) => this.subOver(e, 3, val)}
              onMouseLeave={(e, l) => this.subOut(e, 3, val)}>
              {title}
              <Icon type={'youfanye1'} clm={styles['menu-item-icon']}></Icon>
              {
                this.state.subOverOn && this.state.onVal == val &&
                <SubWrap>
                  <ColSubMenu
                    style={{ top: top + (36 * i), left: 220 }}
                    level={3}
                    items={children}
                    onSubOver={(e, l) => this.subOver(e, 3, val)}
                    onSubLeave={(e, l) => this.subOut(e, 3, val)}
                    activeKey={this.props.activeKey}
                    resetActiveKey={this.props.resetActiveKey}>
                  </ColSubMenu>
                </SubWrap>
              }
            </li>)
          }
        })}
      </ul>
    );
  }
}
export default ColSubMenu;
