import React, { Component } from 'react'
import PropTypes from 'prop-types'
import styles from './index.scss'
import Icon from './../Icon'
import SubWrap from './ColSubWrap'
class MenuItem extends Component {
  constructor(props, content) {
    super(props);
    this.toggleActive = this.toggleActive.bind(this);
    this.itemREF = React.createRef();
    this.state = {
      active: false,
      subOverOn: false
    }
  }
  toggleActive() {
    if (this.props.url == '/#') {
      return false;
    };
    const { collapsed } = this.props;
    if (collapsed) {
      this.props.resetActiveSub([]);
    }
    this.props.resetActiveKey(this.props.val)
  }

  subOver = (e) => {
    e.stopPropagation();
    const { collapsed } = this.props;
    if (!collapsed) return false;
    const hall = this.itemREF.current.offsetTop - document.getElementById('car-menu-con').scrollTop + 36;
    const hcon = document.getElementById('car-menu-con').offsetHeight;
    let hh = 0;
    hh = this.itemREF.current.offsetTop - document.getElementById('car-menu-con').scrollTop;
    this.setState({ subOverOn: true, hh });
  }
  subOut = () => {
    this.setState({ subOverOn: false });
  }

  render() {
    const children = this.props.children;
    const collapsed = this.props.collapsed
    const padNum2 = 46;
    const padNum3 = 62;
    let padNum = this.props.level == 3
      ? padNum2
      : padNum3;

    padNum = this.props.level == 2
      ? 20
      : padNum;
    const padStyle = {
      paddingLeft: padNum + 'px',
      cursor: 'pointer'
    };
    const activeCls = this.props.val == this.props.activeItem
      ? 'car-menu-item-active'
      : 'car-menu-item-noactive'

    return (
      <li
        ref={this.itemREF}
        className={`${styles[activeCls]} ${styles['car-menu-item']}`}
        style={{ ...padStyle, fontSize: this.props.icon ? 16 : 14 }}
        onClick={this.toggleActive}
        onMouseOver={(e) => this.subOver(e, this.itemREF)}
        onMouseLeave={this.subOut}>
        {this.props.icon && <Icon type={this.props.icon} clm={styles['menu-title-icon']}></Icon>}
        {<span>{children}</span>}
        {collapsed && this.state.subOverOn &&
          <SubWrap>
            <div
              className={styles.colitem_tip}
              style={{ top: this.state.hh + 10 + 60 }}>
              {children.props ? children.props.children : children}
            </div>
          </SubWrap>
        }
      </li>)
  }
}

export default MenuItem;
