import React, { Component } from 'react'
import PropTypes from 'prop-types'
import styles from './index.scss'
import SubMenu from './SubMenu.js'
import Icon from './../Icon'
class Menu extends Component {

  constructor(props, content) {
    super(props);
    this.handleActive = this.handleActive.bind(this);
    this.handleActiveItem = this.handleActiveItem.bind(this)
    this.state = {
      activeSub: 'k1',
      activeKey: '',
      defaultActiveSub: [],
      collapsed: false
    }
  }

  handleActive(val) {
    this.setState({ 'activeSub': val })
  }
  handleActiveItem(val) {
    this.setState({ 'activeKey': val })
  }
  setCollapsed = () => {
    const { collapsed } = this.state
    const { defaultActiveSub } = this.state
    const c = this.state.collapsed;
    const dA = !c ? [] : defaultActiveSub;
    const aS = !c ? '' : defaultActiveSub;
    if (this.props.collapsedChange) {
      this.props.collapsedChange(!c)
    }
    this.setState({ collapsed: !c, defaultActiveSub: dA, activeSub: aS });
  }

  componentDidMount() {
    this.setState({
      'activeSub': this.props.defaultActiveSub,
      'activeKey': this.props.defaultActiveItem
    });
  }

  componentWillReceiveProps(nextProps) {
    if (JSON.stringify(nextProps.defaultActiveSub) != JSON.stringify(this.state.defaultActiveSub) && this.state.defaultActiveSub.length != 0) {
      this.setState({
        'activeSub': nextProps.defaultActiveSub,
        'activeKey': this.props.defaultActiveItem,
        defaultActiveSub: nextProps.defaultActiveSub
      });
    }
    if (this.state.collapsed) {
      this.setState({
        'activeSub': nextProps.defaultActiveSub,
        defaultActiveSub: nextProps.defaultActiveSub
      });
    }
  }
  change() {
  }

  render() {
    const children = this.props.children;
    const { canCollapsed } = this.props;
    const { activeSub, activeKey, collapsed } = this.state;
    const subList = React.Children.map(children, (item) => {
      return React.cloneElement(item, {
        activeSub: activeSub,
        resetActiveSub: this.handleActive,
        activeItem: activeKey,
        level: 2,
        activeKey: activeKey,
        resetActiveKey: this.handleActiveItem,
        defaultActiveSub: this.props.defaultActiveSub,
        collapsed: collapsed
      })
    })

    return (
      <div className={styles['car-hq']} id={'car-menu-con'}>
        <div
          className={`${styles['car-menu']} ${this.state.collapsed ? styles['car-menu-collapsed'] : ''}`}>
          <ul className={`${styles['car-menu-sub-list']}`}>
            {canCollapsed &&
              <li
                className={`${styles['car-menu-col-li']} ${styles['car-menu-sub']}`}
                onClick={this.setCollapsed}>
                <Icon
                  clm={`${styles.openIcon} ${collapsed ? styles['col-menu-open'] : ''}`}
                  type={'zhankai'}>
                </Icon>
              </li>

            }
            {subList}
          </ul>
        </div>
      </div>
    )
  }
}
export default Menu;
