import {Component} from 'react';
import styles from './style.scss'
import _event from '../event';
const word = [
  'A',
  'B',
  'C',
  'D',
  'E',
  'F',
  'G',
  'H',
  'I',
  'J',
  'K',
  'L',
  'M',
  'N',
  'O',
  'P',
  'Q',
  'R',
  'S',
  'T',
  'U',
  'V',
  'W',
  'X',
  'Y',
  'Z'
]

class DropBox extends Component {

  constructor(props) {
    super(props);
  }

  componentDidMount() {
    const {hideDrop} = this.props
    _event.addEvent(document, 'click', hideDrop);

    if (this._item) {
      let _top = this._item.offsetTop;
      _top = _top > 56
        ? _top - 56
        : 0;
      this._box.scrollTop = _top
    }
  }

  // 销毁事件
  componentWillUnmount() {
    const {hideDrop} = this.props
    _event.removeEvent(document, 'click', hideDrop);
  }

  // 是否向上传递事件
  enAble = (e) => {
    e.nativeEvent.stopImmediatePropagation();
  }

  getPosition = (id) => {
    const { getP } = this.props;
    let obj = document.getElementById(id);
    let _top = obj.offsetTop;
    let temp = id.split("_")
    let [word] = temp;

    this._box.scrollTop = _top
    getP(word)
  }

  render() {
    const {selectName, typeId, selectWord, list, select} = this.props

    return (
      <div className={styles.dropBox} onClick={this.enAble}>

        {/* 字母索引 */}
        <ul className={styles.word}>
          {
            word.map((item, i) => {
              let cls = selectWord == item
                ? styles.selected
                : ''
              let _act = selectWord == item
                ? 'car-bg__vi' : ''
              return (<li className={`${cls} ${_act}`} onClick={this.getPosition.bind(this, `${item}_${typeId}`)} key={i}>{item}</li>)
            })
          }
        </ul>

        <div className={styles.conter} ref={box => this._box = box}>
          {
            list.map((item, i) => {
              let {name, data} = item;
              let id = `${name}_${typeId}`
              if (data == null) {
                return
              }

              return (<div key={i} className={styles.item} id={id}>
                <div className={styles.itemName}>{name}</div>
                {
                  data.map((two, j) => {
                    let cls = ''
                    if (selectWord == name && selectName == two.name) {
                      cls = styles.itemSelected
                      return (<p ref={item => this._item = item} className={`${cls} car-bg-three__vi car-bg-secend-hover__vi`} onClick={select.bind(this, two, name)} key={j}>{two.name}</p>)
                    } else {
                      return (<p onClick={select.bind(this, two, name)} className={`car-bg-secend-hover__vi`} key={j}>{two.name}</p>)
                    }
                  })
                }
              </div>)
            })
          }
        </div>
      </div>
    )
  }

}

export default DropBox
