import { Component } from 'react';
import styles from './style.scss'
import Icon from '../Icon'
import Drop from './Drop'

class SelectBox extends Component {

  constructor(props) {
    super(props);

    let {
      tempName, // 选中后的分类名称
      tempType, //选中后的分类值
      typeId, // 随机id
      tempWord
    } = this.getData(this.props);

    this.state = {
      drop: false, // 是否处于展开状态
      selectName: tempName, // 选中后的分类名称
      selectType: tempType, //选中后的分类值
      typeId, // 随机id
      selectWord: tempWord
    }
  }

  shouldComponentUpdate(nextProps, nextState) {
    let propsActive = checkUpdate(nextProps, this.props, ['list', 'defaultValue']);
    let stateActive = checkUpdate(nextState, this.state, ['drop', 'selectName', 'typeId', 'selectType', 'selectWord']);
    return propsActive || stateActive;
  }
  async componentWillReceiveProps(nextProps) {
    let propsActive = checkUpdate(nextProps, this.props, ['list', 'defaultValue']);
    if (propsActive) {
      let {
        tempName, // 选中后的分类名称
        tempType, //选中后的分类值
        typeId, // 随机id
        tempWord
      } = this.getData(nextProps);
      this.setState({
        drop: false, // 是否处于展开状态
        selectName: tempName, // 选中后的分类名称
        selectType: tempType, //选中后的分类值
        typeId, // 随机id
        selectWord: tempWord
      })
    }
  }

  getData = (props) => {
    let typeId = new Date().getTime();

    let { list, defaultValue } = props;

    list = list
      ? list
      : false;

    let temp = false;
    if (defaultValue && list) {
      temp = list.find(item => {
        let { name, data } = item;
        if (data == null) {
          return false
        }
        return data.find(two => {
          return two.name == defaultValue.name && two.id == defaultValue.id
        })
      })
    }

    let tempWord = temp
      ? temp.name
      : 'A';

    let tempName = defaultValue
      ? defaultValue.name
      : null;

    let tempType = defaultValue
      ? defaultValue.id
      : null;

    return {
      tempName, // 选中后的分类名称
      tempType, //选中后的分类值
      typeId, // 随机id
      tempWord
    }
  }

  // 隐藏下拉
  hideDrop = () => {
    this.setState((next) => {
      return {
        drop: !next.drop
      }
    })
  }

  // 选择类型
  select = (value, name) => {
    const { change } = this.props
    this.setState((next) => {
      return { selectName: value.name, selectType: value.id, drop: false, selectWord: name }
    })

    change(value)
  }

  getP = (word) => {
    this.setState(() => {
      return { selectWord: word }
    })
  }

  render() {
    const { selectName, drop, typeId, selectWord } = this.state;
    const { descript, list, style } = this.props

    // 判断是展开还是收起
    let activeCls = drop
      ? styles.active
      : ''

    // 根据是否有选中的值，判断是渲染描述，还是渲染选中项
    const showSelect = () => {
      return selectName
        ? <div>{selectName}</div>
        : <div className={styles.descript}>{descript}</div>
    }

    return (
      <div className={styles['car-drop-box']}>
        <div className={styles.SelectBox}>

          {/* 头部 */}
          <div
            onClick={this.hideDrop}
            className={`${styles.head} ${activeCls} car-border-hover__vi`}
            style={{ ...style }}
          >
            {showSelect()}
            <Icon type='xiala' />
          </div>

          {/* 下拉展开 */}
          {drop && <Drop selectName={selectName} typeId={typeId} selectWord={selectWord} list={list} hideDrop={this.hideDrop} select={this.select} getP={this.getP} />}
        </div>
      </div>
    )
  }
}

export default SelectBox
