import React, { Component } from 'react';
import styles from './index.scss';
import SelectItem from './SelectItem';
class Select extends Component {
    constructor(props, content) {
        super(props);
        this.state = {
            leftData: [],
            rightData: [],
            leftSelect: [],
            rightSelect: [],
        }
    }

    componentDidMount = () => {
        const { data, rightData } = this.props;
        if (rightData.length === 0) {
            this.setState({ leftData: data, rightData: [] })
        }
    }

    selectChange = (checked, key, type) => {
        const target = type === 'leftData' ? 'leftSelect' : 'rightSelect';
        const dataTarget = this.state[target];
        const dataFrom = this.state[type];
        dataFrom.forEach((item) => {
            if (item.key === key) {
                checked ? dataTarget.push(item) : dataTarget.splice(dataTarget.indexOf(item), 1);
            }
        });
        this.setState({ [target]: dataTarget });
    }
    tranData = (form) => {
        const from = form === 'right' ? 'rightSelect' : 'leftSelect';
        const fromData = this.state[from];
        const target = form === 'right' ? 'leftData' : 'rightData';
        const del = form === 'right' ? 'rightData' : 'leftData';
        const targetData = this.state[target];
        const delData = this.state[del];
        fromData.forEach((item) => {
            console.log("---ffffff---", item);
            delData.splice(delData.indexOf(item), 1)
        });
        this.setState({ [target]: [...targetData, ...fromData], [from]: [], [del]: delData })
    }

    render() {
        const { data } = this.props;
        const { leftData, rightData } = this.state;
        return (
            <div className={styles.test_s_content}>
                <div className={`${styles.s_con_item} ${styles.s_left_con}`}>
                    <ul>
                        {
                            leftData.map((item) => {
                                return (
                                    <SelectItem
                                        onChange={(checked, key) => this.selectChange(checked, key, 'leftData')}
                                        item={item}>
                                    </SelectItem>)
                            })
                        }
                    </ul>
                </div>
                <div className={styles.btn_con}>
                    <a onClick={() => this.tranData('left')}>left to right</a>
                    <a onClick={() => this.tranData('right')}>right to left</a>
                </div>
                <div className={`${styles.s_con_item} ${styles.s_right_con}`}>
                    <ul>
                        {
                            rightData.map((item, i) => {
                                return (
                                    <SelectItem
                                        key={`test-sitme-${i}`}
                                        onChange={(checked, key) => this.selectChange(checked, key, 'rightData')}
                                        item={item}>
                                    </SelectItem>)
                            })
                        }
                    </ul>
                </div>
            </div >)
    }
}

// data item
// {id,title}
Select.defaultProps = {
    data: [],
    rightData: [],
}
export default Select
