import React, {Component} from 'react';
import styles from './style.scss';
import Icons from '_c/Icon';
import _ from 'lodash';

// 版本
class Compound extends Component {
  state = {
    acitve: false, // 展开状态
    dropIndex: 0,
    select: {
      all: true
    }
  }

  static getDerivedStateFromProps(props, state) {
    if (!_.eq( props.select, state.select )) {
      return {
        select: props.select
      };
    }
    return null;
  }

  // 版本点击
  selectAll = (index) => {

    this.setState(state =>{
      const { list } = this.props;
      let data = list[index];

      let preData = state.select;

      let obj = {};

      let nowT = preData[`_${data.value}`]
      // 验证已选的选择框中是否存在该项
      if(nowT){
        // 验证该版本是否选择的是全部
        let listLen = data.child.length;
        let nLen = nowT.select.length;
        if(listLen === nLen){
          delete preData[`_${data.value}`]
        }else{
          obj.status = true; // 是否被全选
          obj.value = data.value;
          obj.select = data.child.map(item => item.value);
          preData[`_${data.value}`] = obj;
        }
      }else{
        obj.status = true; // 是否被全选
        obj.value = data.value;
        obj.select = data.child.map(item => item.value);
        preData[`_${data.value}`] = obj;
      }

      // 验证是否已经被全部选中
      let temp = list.map(item => {
        let _child = item.child.map(two => two.value)
        return {
          value: item.value,
          select: _child
        }
      })

      let active = temp.every(item => {
        let _key = item.value;
        let _arr = item.select
        if(preData[`_${_key}`]){
          let preArr = preData[`_${_key}`].select;
          if(JSON.stringify(preArr) === JSON.stringify(_arr)){
            return true
          }else{
            return false
          }
        }else{
          return false
        }
      })

      let _tem = temp.map(item => preData[`_${item.value}`]).filter(item => item !== undefined );
      if(_tem.length > 0){
        preData.all = active;
      }else{
        preData.all = true;
      }

      return {
        dropIndex: index,
        select: preData
      }
    })
  }

  selectChild = (pIndex, cIndex) => {
    this.setState(state => {
      const { list } = this.props;
      let preData = state.select;

      let data = list.find(item => item.value === pIndex);

      let obj = {};

      // 判断其父元素是否被选中过
      if(preData[`_${pIndex}`]){
        let _arr = preData[`_${pIndex}`].select;
        let ind = _arr.findIndex(item => item == cIndex);
        if(ind === -1){
          _arr.push(cIndex);
          obj.value = pIndex;
          if(data.child.length === _arr.length){
            obj.status = true; // 是否被全选
            obj.select = data.child.map(item => item.value);
            preData[`_${pIndex}`] = obj;
          }else{
            obj.status = false; // 是否被全选
            obj.select = _arr;
          }
        }else{
          _arr.splice(ind, 1);
          // 验证是否一个都没有选中
          if(_arr.length === 0){
            delete preData[`_${pIndex}`]
          }else{
            obj.status = false; // 是否被全选
            obj.value = pIndex;
            obj.select = _arr;
            preData[`_${pIndex}`] = obj;
          }
        }
      }else{
        obj.status = false; // 是否被全选
        obj.value = pIndex;
        obj.select = [cIndex]
        preData[`_${pIndex}`] = obj;
      }

      // 验证是否已经被全部选中
      let temp = list.map(item => {
        let _child = item.child.map(two => two.value)
        return {
          value: item.value,
          select: _child
        }
      })

      let active = temp.every(item => {
        let _key = item.value;
        let _arr = item.select
        if(preData[`_${_key}`]){
          let preArr = preData[`_${_key}`].select;
          if(JSON.stringify(preArr) === JSON.stringify(_arr)){
            return true
          }else{
            return false
          }
        }else{
          return false
        }
      })


      let _tem = temp.map(item => preData[`_${item.value}`]).filter(item => item !== undefined );
      if(_tem.length > 0){
        preData.all = active;
      }else{
        preData.all = true;
      }

      return {
        select: preData
      }
    })
  }

  setDrop =() => {
    let now = this.state.acitve;
    if(now){
      this.close()
    }
    this.open()
  }

  open = () => {
    this.setState({acitve: true})
  }

  close = () => {
    this.setState({ acitve: false, dropIndex: 0 })
    const { select } = this.state;
    this.props.handleChange(select);
  }

  render(){
    const { acitve, dropIndex, select } = this.state;
    const { list } = this.props;

    // 验证是否被全部选中
    let title = '多个版本';
    if(select.all){
      title = '全部版本';
    }
    return (
      <div className={styles.compound}>
        <div className={styles.box} onClick={this.setDrop}>
          {title}
          <Icons type='benjingpinloudou1' />
        </div>
        {
          acitve && <div onClick={this.close} className={styles.mask}></div>
        }
        {
          acitve && (
            <div className={styles.drop}>
              <div className={styles.list}>
                {
                  list.map((item, i)=>{
                    let childList = item.child;
                    let _key = item.value;
                    // 父元素的选中状态
                    let pActive;
                    let temp = select[`_${_key}`];
                    let _arr = []
                    if(temp){
                      pActive = styles.selected;
                      _arr = temp.select;
                    }
                    let childSty = dropIndex == i ? { display:'block'} : {};
                    return (
                      <div className={styles.item} key={i}>
                        <div
                          className={`${styles.select} ${pActive}`}
                          onClick={this.selectAll.bind(this,i)}
                        >
                          {item.name}
                        </div>
                        <div className={styles.itemChild} style={childSty}>
                          {
                            childList.map((two, j) => {
                              let _cActive;
                              if(_arr.find(three => three == two.value)){
                                _cActive = styles.selected;
                              };

                              return (
                                <div
                                  key={j}
                                  className={`${styles.itemlist} ${_cActive}`}
                                  onClick={this.selectChild.bind(this, _key, two.value)}
                                >
                                  {two.name}
                                  {_cActive && <Icons type='yixianggoucheng-xiazai-gouxuan' />}
                                </div>
                              )
                            })
                          }
                        </div>
                      </div>
                    )
                  })
                }
              </div>
            </div>
          )
        }
      </div>
    )
  }
}
export default Compound
