/**
 * Created by TDS on 2019/4/24.
 */
import enUs from "./en_US";
import zhCn from "./zh_CN";
// 获取语言
export function getLanguage() {
  const lang = navigator.language || navigator.userLanguage; // 常规浏览器语言和IE浏览器
  const localStorageLang = localStorage.getItem("lang");
  const defaultLang = localStorageLang || lang;
  const locationLang = window.location.host == 'bigdata.autohome.com.cn' ? 'zh' : 'en';
  return defaultLang;
}

// 设置语言
export function setLanguage(lang) {
  const defaultLang = localStorage.setItem("lang", lang);
  return defaultLang;
}

// 匹配语言
export function chooseLocale() {
  switch (getLanguage()) {
    case "en":
      return enUs;
    case "zh":
      return zhCn;
    default:
      return zhCn;
  }
}
