import React, { Component } from 'react';
import styles from './style.scss';
import toThousands from './to-thousands';

class Proportion extends Component {
  state = {}

  render() {
    const {
      title,
      title_1,
      title_2,
      unit,
      total,
      selected,
      waveColor,
      enStatus,
      _width
    } = this.props;

    let ratio = Math.round((selected / total) * 100)
    let _top = ratio + 70;

    let _sty = enStatus ? styles['distribution-top-one'] : ''

    return (
      <div className={styles['proportion']}>

        {/*  圆圈的盒子  */}
        <div className={styles['circle-box']}>
          <div className={styles['circle-box-yuan']}>
            <div
              className={styles['circle']}
              style={{ borderColor: waveColor }}
            >
              {/* 波纹效果 */}
              <div
                className={styles['wave']}
                style={{
                  top: `${-_top}%`,
                  backgroundColor: waveColor,
                }}
              >
              </div>
            </div>
            <span>{ratio}%</span>
          </div>

          <p>{title}</p>
        </div>

        {/*  用户数  */}
        <div className={styles['distribution-box']}>
          <div className={styles['distribution-top']}>
            <p className={_sty} style={{ width: _width }}>{title_1}</p>
            <p className={_sty}>{toThousands(selected)} {unit}</p>
          </div>
          <div className={styles['distribution-bottom']}>
            <p style={{ width: _width }}>{title_2}</p>
            <p>{toThousands(total)} {unit}</p>
          </div>
        </div>
      </div>
    )
  }
}

export default Proportion
