import React, { Component } from 'react';
import styles from './style.scss';

import Dropdown from '_c/Button/Dropdown';

import DropItem from '_c/Button/DropItem';

import Table from 'antd/lib/table';

// 国际化处理程序
import { getWord } from 'auto-gjh';


class Tables extends Component {

  state = {
    downList: [
      {
        lable: 'down',
        name: getWord('下载Excel表格格式'),
        value: 1
      },
    ]
  }

  down = (value) => {
    const { downExcel } = this.props;
    downExcel(value);
  }


  render() {
    const { downList } = this.state;
    const { columns, data, pmark, name, seriesType, eventType } = this.props

    const _h = window.innerHeight - 200;
    let _w;

    if (seriesType) {
      _w = 2380
    } else {
      _w = 3400
    }

    if (eventType) {
      _w -= 1050;

      if (!seriesType) {
        _w -= 300;
      }
    }

    return (
      <div className={styles['tables']}>
        <div className={styles['tables-header']}>

          {/*   头部标题及下载按钮  */}
          <div className={styles['tables-title']}>
            {name} <span>{getWord('人群包基本属性')}</span>
          </div>
          {
            !eventType &&
            <Dropdown
              data-role="download"
              style={{ float: 'right' }}
              size={'small'}
              icon={'xiazai'}
              title={getWord('下载')}
              placement='right'
            >
              {
                downList.map((item, i) => {
                  const attr = {};
                  if (pmark && item.name !== ' 添加至购物车') {
                    let _type = item.name === getWord('下载Excel表格格式')
                      ? 'excel-download'
                      : 'png-download'

                    attr['data-click'] = JSON.stringify({
                      type: _type,
                      pmark: pmark,
                      title: name
                    });

                  }
                  return (
                    <DropItem
                      key={`down${i}`}
                      onClick={this.down.bind(this, item.value)}>
                      <span {...attr}>{item.name}</span>
                    </DropItem>
                  )

                })
              }
            </Dropdown>
          }

        </div>

        {/*  表格主体  */}
        <div className={styles['table-box']}>
          <Table
            key={Math.random()}
            rowKey={record => record.orderNum}
            bordered
            align='center'
            columns={columns}
            dataSource={data}
            size="middle"
            scroll={{ x: _w, y: _h }}
          />
        </div>

      </div>
    )
  }
}

export default Tables
