import charts from './chart';

// 获取语言版本
const getLang = () => {
    let lang = '';
    return () => {
        if (lang !== '') return lang;
        lang = sessionStorage.getItem('lang');
        return lang;
    }
}

const langs = getLang()

// 获取对应的单词映射
const getword = (source) => {
    // 找到对应的单词映射
    let word = charts.find((item) => item.zh === source);
    // 如果找到就返回对应的单词
    if (word) {
        let type = langs();
        let str = word[type];
        if(str){
            return str;
        }
    }

    // 如果没有就按原样返回
    return source;
}

export default getword;