import React, { Component } from 'react'
import Button from '../components/Button/Button';
import Icon from '../components/Icon';
import ButtonGroup from '../components/Button/ButtonGroup';
import Tabs from '../components/Tabs'
import Pane from '../components/Tabs/Pane'
import Menu from '../components/Menu'
import SubMenu from '../components/Menu/SubMenu'
import MenuItem from '../components/Menu/MenuItem'
import DatePick from '../components/Date'
import Tag from '../components/Tag'
import Select from '../components/Select'
import Option from '../components/Select/Option'
import Dorpdown from '../components/Button/Dropdown'
import DorpItem from '../components/Button/DropItem'
import Chart from '../components/Chart/box'
import SelectBox from '../components/SelectBox'

import '../demo.scss';
import '@/reset/index.scss';


class ViewClass extends Component {
  constructor(props, content) {
    super(props);
    this.testClick = this.testClick.bind(this);
    this.testClick2 = this.testClick2.bind(this);
    this.state = {
      'testValue': '1111',
      testDateType: '2017-12',
      subling: null,
      hei: 1000
    }
  }
  testClick() {
    this.setState({
      'hei': this.state.hei + 50
    })
  }
  testClick2() {
    this.setState({ 'testValue': '3333' })
  }
  testSelectChange(value, t) {
    //this.setState({'testValue': '3333'})
    console.log('------testSelectChange-----', value, t);
  }
  testIconClick() {
    console.log('------icon----click-----');
  }

  testDropItem() {
    console.log('------testDropItem-----');
  }
  testTabsChange() {
    console.log('------testTabsChange-----');
  }

  typeChage = (value) => {
    switch (value) {
      case 'month':
        this.setState({ testDateType: '2017-12' })
        break;
      case 'quarter':
        this.setState({ testDateType: '2017Q4' })
        break;
      case 'year':
        this.setState({ testDateType: '2017' })
        break;
    }
  }

  componentDidMount() {
    this.setState({ subling: this._box })
  }
  render() {
    const { testDateType, subling, hei } = this.state;
    return (<div className='main'>
      <div className='menu-con'>
        <Menu defaultActiveSub={['k2', 'k6']} defaultActiveItem={'i7'}>
          <SubMenu icon={'sousuo'} val={'k1'} title={'车主画像'}>
            <MenuItem val={'i1'}>车主画像车主画像1</MenuItem>
            <MenuItem val={'i2'}>车主画像2</MenuItem>
          </SubMenu>
          <SubMenu icon={'guanggaowei'} val={'k2'} title={'潜客画像'}>
            <MenuItem>对比分析对比分析</MenuItem>
          </SubMenu>
          <SubMenu icon={'xiaoshouyuce1'} val={'k3'} title={'市场画像'}>
            <MenuItem val={'i11'}>设备偏好</MenuItem>
            <MenuItem val={'i12'}>设备偏好</MenuItem>
            <MenuItem val={'i13'}>设备偏好</MenuItem>
            <MenuItem val={'i14'}>设备偏好</MenuItem>
          </SubMenu>
        </Menu>
      </div>

      <div className='car-con'>
        <article>
          <Tabs>
            <Pane title='123' value={2} data-ss='234234'>
              sdfsadf
            </Pane>
            <Pane title='34534' value={4} data-ss={{
              a: 23423,
              b: 444
            }}>
              ssdfsdf</Pane>
          </Tabs>
        </article>

        <article>
          <span>车系</span>
          <SelectBox change={(value) => {
            console.log(value);
          }} defaultValue={{
            name: '别克',
            id: '30'
          }} list={testList} descript="选择车系" />
        </article>
        <article>
          <Chart loading={true} style={{
            height: hei
          }} title={[
            <span>手机系统</span>,
            <p>
              <span>奥迪Q3 N=1123</span>
              <em>/</em>
              <span>奥迪Q3 N=1123</span>
            </p>
          ]}></Chart>
        </article>
        <article>
          <h2 className='title'>Date</h2>
          <div className='item'>
            <DatePick select='mulit' inputStyle={{
              width: 150
            }} direction='right' sectionNum={7} describe={true} placehold='选择日期' selectType={['year', 'quarter', 'month', 'week', 'day']} defaultValue={testDateType} min='2016-11-30' max='2018-05-21' size={4} typeChage={this.typeChage} onChange={(value, type, lab) => {
              this.setState(() => {
                console.log(value, type, lab);
                return { testDateType: value }
              })
            }} />
          </div>
        </article>
        <article>

          <h2 className='title'>Dorpdown</h2>
          <div className='item'>
            <div className='item'>
              <Dorpdown size={'small'} icon={'xiala'} title={'下拉按钮'}>
                <DorpItem data-a='222' data-ss={{
                  a: 23423,
                  b: 444
                }}>test1</DorpItem>
                <DorpItem data-a='222'>选项1</DorpItem>
                <DorpItem data-a='222'>选项1</DorpItem>
                <DorpItem data-a='222'>选项1</DorpItem>
                <DorpItem a='222'>选项1</DorpItem>
              </Dorpdown>
            </div>
            <div className='item'>
              <ButtonGroup>
                <Dorpdown placement='left' size={'small'} icon={'xiala'} title={'下拉组合'}>
                  <DorpItem onClick={this.testDropItem}>选项1</DorpItem>
                  <DorpItem>选项1</DorpItem>
                  <DorpItem>选项1</DorpItem>
                  <DorpItem>选项1</DorpItem>
                  <DorpItem>选项1</DorpItem>
                </Dorpdown>
                <Dorpdown placement='right' size={'small'} icon={'xiazai'} title={'下载'}>
                  <DorpItem>选项111111111111</DorpItem>
                  <DorpItem>选项122222222222</DorpItem>
                  <DorpItem>选项133333</DorpItem>
                  <DorpItem>选项1444</DorpItem>
                  <DorpItem>选项1555555</DorpItem>
                </Dorpdown>
              </ButtonGroup>
            </div>

          </div>
        </article>
        <article>
          <h2 className='title'>Button</h2>
          <p className='item'>
            <Button type={'primary'} onClick={this.testClick}>主按钮</Button>
            <Button type={'default'} onClick={this.testClick2}>次按钮</Button>
          </p>
          <p className='item'>
            <Button type={'primary'} size={'large'}>large按钮</Button>
            <Button type={'default'} size={'large'}>large按钮</Button>
            <Button type={'primary'} size={'small'}>small按钮</Button>
            <Button type={'default'} size={'small'}>small按钮</Button>
          </p>
          <p className='item'>
            <Button type={'primary'} disabled="disabled">禁用状态</Button>
          </p>
          <p className='item'>
            <Button type={'primary'}>
              icon
              <Icon type={'jiantouxia'} />
            </Button>
            <Button type={'default'}>
              <Icon type={'baojia'} />
              icon
            </Button>
          </p>
          <div className='item'>
            <ButtonGroup>
              <Button type={'default'}>
                icon
                <Icon type={'xiaoshouyuce1'} />
              </Button>
              <Button type={'default'}>
                <Icon type={'xiaoshouyuce1'} />
                icon
              </Button>
            </ButtonGroup>

          </div>
          <div className='item'>
            <ButtonGroup>
              <Button type={'default'}>
                icon
                <Icon type={'xiaoshouyuce1'} onClick={this.testIconClick} />
              </Button>
              <Button type={'default'}>
                中间
              </Button>
              <Button type={'default'}>
                中间
              </Button>
              <Button type={'default'}>
                中间
              </Button>
              <Button type={'default'}>
                <Icon type={'xiaoshouyuce1'} />
                icon
              </Button>
            </ButtonGroup>
          </div>
        </article>

        <article>
          <h2 className='title'>Tag</h2>
          <div className='item'>
            <Tag>标签A6</Tag>
            <Tag>奥迪A6</Tag>
          </div>
        </article>
        <article>
          <h2 className='title'>Select</h2>
          <div className='item'>
            <Select onChange={(e) => {
              this.testSelectChange(e, 'test')
            }} value={this.state.testValue} defauleValue={'1111'} placeholder={'请选择'} width={300}>
              <Option value='1111' object={'obj1'}>{'1111'}</Option>
              <Option value='2222' object={'obj2'}>{'2222'}</Option>
              <Option value='3333' object={'obj3'}>{'3333'}</Option>
            </Select>
            <Select onChange={(e) => {
              this.testSelectChange(e, 'test')
            }} value={this.state.testValue} defauleValue={'1111'} placeholder={'请选择'} width={300}>
              <Option value='1111111111111111111111111111111111111111111111111111111111111111' object={'obj1'}>{'111111111111111111111111111111111111111111111111111111111111'}</Option>
              <Option value='2222' object={'obj2'}>{'2222'}</Option>
              <Option value='3333' object={'obj3'}>{'3333'}</Option>
            </Select>
            <Select onChange={(e) => {
              this.testSelectChange(e, 'test')
            }} value={this.state.testValue} defauleValue={'1111'} placeholder={'请选择'} width={300}>
              <Option value='1111111111111111111111111111111111111111111111111111111111111111' object={'obj1'}>{'t1'}</Option>
              <Option value='2222' object={'obj2'}>{'2222'}</Option>
              <Option value='3333' object={'obj3'}>{'3333'}</Option>
            </Select>
            <Select onChange={(e) => {
              this.testSelectChange(e, 'test')
            }} value={this.state.testValue} defauleValue={'1111'} placeholder={'请选择'} width={300}>
              <Option value='1111111111111111111111111111111111111111111111111111111111111111' object={'obj1'}>{'t2'}</Option>
              <Option value='2222' object={'obj2'}>{'2222'}</Option>
              <Option value='3333' object={'obj3'}>{'3333'}</Option>
            </Select>
          </div>
        </article>
      </div>
    </div>)
  }
}

export default ViewClass;
