import React, { Component } from "react";
import Uvn from "_c/uvn";
import styles from "./style.scss";
import { getDatas, getData2 } from "./testData";
import Loading from "_c/Chart/Loading";

// 国际化处理程序
import { getWord } from "auto-gjh";
import { log } from "util";
import { Table } from "antd";

class Uvns extends Component {
  state = {
    options: null,
    drop: true,
    visible: false,
    lineChart: {},
  };
  async componentDidMount() {
    let _series = await getDatas("0", 1);
    let _series_1 = await getDatas("0", 2);
    let _compet = await getDatas("3170", 1);
    let _compet_1 = await getDatas("3170", 2);

    this.setState({
      options: {
        seriesData: _series,
        seriesBiaoData: _series_1,
        competData: _compet,
        competBiaoData: _compet_1,
        compet: true, // 是否开启竞品
        type: false, // true: 城市级别  false: 城市级别 * 待机
        axis: {
          u: getWord("城市级别"),
          v: getWord("收入等级"),
          n: getWord("族群偏好"),
        },
        seriesCompet: ["奥迪A6L", "宝马", getWord("自动切换")],
      },
      uvnNames: {
        uName: getWord("城市级别 * 代际"),
        vName: getWord("收入等级"),
        nName: getWord("族群偏好"),
      },
    });
  }

  downLoad = () => {};

  dianji = () => {
    this.setState((state) => {
      return {
        drop: !state.drop,
      };
    });
    window.dispatchEvent(new Event("resize"));
  };

  showFenqun = async (value) => {
    // let _series_1 = await getData2('0', value);
    this.setState({ visible: true });
    // console.log(_series_1)
  };

  handleCancel = () => {
    this.setState({ visible: false });
  };

  render() {
    const { options, uvnNames, drop } = this.state;
    console.log("--------------------");
    console.log(options);
    console.log("--------------------");

    return (
      <div className={styles["bc"]}>
        {drop && <div className={styles["box"]}>容器</div>}
        <div style={{display:'none'}}>
          <Table />
        </div>

        <div className={styles["click"]} onClick={this.dianji}>
          点击
        </div>
        {options ? (
          <Uvn
            options={options}
            eventType={false}
            uvnNames={uvnNames}
            downLoad={this.downLoad}
            tableShow={false}
            tabType={true}
            showFenqun={this.showFenqun}
            visible={this.state.visible}
            handleCancel={this.handleCancel}
            lineChart={this.state.lineChart}
          />
        ) : (
          <div className={styles["loading"]}>
            <Loading />
          </div>
        )}
      </div>
    );
  }
}

export default Uvns;
