import _ from 'lodash';

import axios from 'axios';
axios.defaults.timeout = 100000;
axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';

export const getDatas = (id, type) => {
  return axios({
    url: 'https://bigdata.autohome.com.cn/sales/uvnb/cells',
    method: 'get',
    params: {
      clusterType: type,
      userType: 1,
      date: '2018-07',
      seriesId: '18',
      compete: id,
      type: 1,
      groupId: 0,
      uType: 'ut3',
      vType: 'vt1',
      nType: 'nt1',
    },
    withCredentials: true,
    headers: {
      'LANGUAGE': 'zh'
    }
  }).then(res => {
    try {
      return res.data.data
    } catch (e) {
      throw new Error(e)
    }
  });
}

export const getData2 = (id, list) => {
  return axios({
    url: 'http://newtestbigdata.yz.test.autohome.com.cn/sales/uvnb/cluster/trend',
    method: 'post',
    params: {
      clusterList: list,
      userType: 1,
      date: '2019-07',
      seriesId: '650',
      compete: id,
      type: 1,
      uType: 'ut3',
      vType: 'vt1',
      nType: 'nt1',
    },
    withCredentials: true,
    headers: {
      'LANGUAGE': 'zh'
    }
  }).then(res => {
    try {
      return res.data.data
    } catch (e) {
      throw new Error(e)
    }
  });
}

