/*
  用于进行数据对比（检查前后是否发生了变化）
  parmas
  @next : 下一次的props
  @prev ： 上一次的props
  @checkArr : 需要检测的字段
*/
const checkUpdate = ( next = {}, prev = {}, checkArr = [] ) => {

  // 如果全部对比都相等,那么代表数据没有发生变化,那么返回false,阻止组件更新
  let temp = checkArr.every( item => {
    // 获取之前与之后的数据
    let tempNew = next.hasOwnProperty(item) ? next[item] : {};
    let tempOld = prev.hasOwnProperty(item) ? prev[item] : {};

    // 将数据转化为字符串
    tempNew = JSON.stringify(tempNew);
    tempOld = JSON.stringify(tempOld);

    // 判断前后是否一致
    return tempNew === tempOld
  })

  return !temp
}

export default checkUpdate
