import checkUpdate from './_checkUpdate';
import getChart from './_getChart';
import checkObject from './_checkObject'

/* 深度克隆方法 根据实际应用案例和场景先不考虑 Map Set Arguments Buff 等特殊类型 @param  {object} obj 克隆对象 @return {object} 返回新的克隆对象 */
const deepClone = function(obj) {
  // 先检测是不是数组和Object
  // let isArr = Object.prototype.toString.call(obj) === '[object Array]';
  let isArr = Array.isArray(obj);
  let isJson = Object.prototype.toString.call(obj) === '[object Object]';
  if (isArr) {
    // 克隆数组
    let newObj = [];
    for (let i = 0; i < obj.length; i++) {
      newObj[i] = deepClone(obj[i]);
    }
    return newObj;
  } else if (isJson) {
    // 克隆Object
    let newObj = {};
    for (let i in obj) {
      newObj[i] = deepClone(obj[i]);
    }
    return newObj;
  }
  // 不是引用类型直接返回
  return obj;
};

Object.prototype.deepClone = function() {
  return deepClone(this);
};
Object.defineProperty(Object.prototype, 'deepClone', {enumerable: false});

window.getChart = getChart;
window.checkUpdate = checkUpdate;
window.checkObject = checkObject;
